var ws=null,wc=null;
/**
 * app 增量及全量升级模块
 * @author jinbing
 */
mui.plusReady(function(){
  if (window.plus) {
    initPlugin();
    checkAppVersion();
  } else {
    document.addEventListener('plusready', checkAppVersion, false);
    document.addEventListener('plusready',initPlugin,true);
  }
  ws=plus.webview.currentWebview();
//	ws.addEventListener("maskClick",function(){
//		wc.close("auto");
//	},false);
});

//检查软件更新
function checkAppVersion() {
  plus.runtime.getProperty(plus.runtime.appid, function(inf) {
    var wgtVer = inf.version;
    //      console.log("当前应用版本：" + wgtVer);
    update(wgtVer);
  });
}

function update(version) {
  var deviceType = plus.os.name == "Android" ? 0 : 1; //0 安卓，1 ios
  mui.ajax(xnzbUrl + '/api-report/version/queryVersionInfo', {
    data: {
      deviceType: deviceType,
      version: version
    },
    dataType: 'json',
    type: 'get',
    timeout: 10000,
    success: function(data) {
      console.log('版本信息' + JSON.stringify(data));
      if(!data.code) {
        appVersionInfo = data.data.appVersionInfo;
        if(appVersionInfo != null) {
          //如果服务器返回的版本号大于现有的则更新
          if(compareVersion(version,appVersionInfo.version)) {
            confirmAction('更新', appVersionInfo.changeLog, appVersionInfo.downUrl, appVersionInfo.forceUpdate,false);
          }else{
            //比对资源版本号
            //var ResourceVersion = ResourceVersion;//plus.storage.getItem("up_ResourceVersion");
            console.log(ResourceVersion+'---------------取资源版本号比对版本（前面是本地，后面是服务器）'+appVersionInfo.resourceVersion+"---------------------是否忽略主版本号更新----------"+appVersionInfo.isIgnoreMainVersion);
            if(appVersionInfo.isIgnoreMainVersion==1){
              if(compareVersion(ResourceVersion,appVersionInfo.resourceVersion)) {
                if (appVersionInfo.resourceForceUpdate == 1) {
                  downWgt(false, appVersionInfo.resourceUrl, true);
                  console.log(appVersionInfo.resourceUrl + "-----------静默更新");
                } else {
                  confirmAction('增量更新', '本次更新将消耗极少流量，请放心更新', appVersionInfo.resourceUrl, 1, true);
                  console.log(appVersionInfo.resourceUrl + "-----------提示更新");
                }
              }
            }else{
              if(compareResVersion(ResourceVersion,appVersionInfo.resourceVersion)){
                if(appVersionInfo.resourceForceUpdate==1){
                  downWgt(false,appVersionInfo.resourceUrl,true);
                  console.log(appVersionInfo.resourceUrl+"-----------静默更新");
                }else{
                  confirmAction('增量更新','本次更新将消耗极少流量，请放心更新',appVersionInfo.resourceUrl,1,true);
                  console.log(appVersionInfo.resourceUrl+"-----------提示更新");
                }
              }
            }
          }
        }
      } else {
        mui.toast(data.msg);
      }
    },
    error: function(xhr, type, errorThrown) {
      mui.toast('网络繁忙，请稍后重试！');
    }
  });
}

function confirmAction(title, description, url, mustUpdate,isResource) {
  var buttons;
  if(mustUpdate == 1) {
    buttons = ['立即更新'];
  } else {
    buttons = ['立即更新', '取消'];
  }
  plus.nativeUI.confirm(description, function(event) {
    // var url='itms-apps://itunes.apple.com/cn/app/hello-h5+/id682211190?l=zh&mt=8';// HelloH5应用在appstore的地址
    if(event.index == 0) {
      if(plus.os.name == "Android"){
        downWgt(true,url,isResource);
      }else{
        if(isResource){
          downWgt(true,url,isResource);
        }else{
          plus.runtime.openURL(url);
        }
      }
    }
    if(!isResource && mustUpdate == 1 && plus.os.name == "Android" && event.index != 0) {
      //安卓上的bug修复
      plus.runtime.quit();
    }
  }, title, buttons);
}

// 显示侧滑页面
function showSide(key,url,isResource,appVersionInfo){
  // 防止快速点击可能导致多次创建
  if(wc){
    return;
  }
  // 开启遮罩
  ws.setStyle({mask:"rgba(0,0,0,0.5)"});
  var subindex = plus.webview.getWebviewById("sub_index");
  if(subindex) {
    subindex.setStyle({mask: "rgba(0,0,0,0.5)"});
  }
  // 创建侧滑页面
  //	wc=plus.webview.create("webview_mask_side.html","up_page",{width:'90%',height:'192px',left:'5%',top:'200px',bottom:'100px',border-radius:'4px'},{key:key,url:url,isResource:isResource});
  wc=plus.webview.create("src/update/webview_update.html","up_page",{width:'90%',height:'192px',left:'5%',top:'200px',bottom:'100px'},{key:key,url:url,isResource:isResource,appVersionInfo:appVersionInfo});
  // 侧滑页面关闭后关闭遮罩
  wc.addEventListener('close',function(){
    ws.setStyle({mask:"none"});
    wc=null;
    if(subindex) {
      subindex.setStyle({mask: "rgba(0,0,0,0.5)"});
    }
  },false);
  // 侧滑页面加载后显示（避免白屏）
  wc.addEventListener("loaded",function(){
    wc.show("slide-in-right",200);
  },false);
}

function downWgt(key,url,isResource) {
  if(key){
    showSide(key,url,isResource,appVersionInfo);
  }else{
    var fileName = '';
    var options = {
      filename: "_doc/update/"
    };
    var dtask = plus.downloader.createDownload(url, options, function(d, status) {
      if (status == 200) {
        if(isResource){
          fileName = d.filename.substring(1, d.filename.length);
          console.log(fileName);
          upzip(fileName);
        }
      } else {
        if (key) {
          plus.nativeUI.alert("安装包下载失败！");
        }
      }
    });
    dtask.start();
  }
}

/**
 * 比较版本大小，如果新版本nv大于旧版本ov则返回true，否则返回false
 * @param {String} ov
 * @param {String} nv
 * @return {Boolean}
 */
function compareVersion(ov, nv) {
  if (!ov || !nv || ov == "" || nv == "") {
    return false;
  }
  var b = false,
      ova = ov.split(".", 4),
      nva = nv.split(".", 4);
  for (var i = 0; i < ova.length && i < nva.length; i++) {
    var so = ova[i],
        no = parseInt(so),
        sn = nva[i],
        nn = parseInt(sn);
    if (nn > no || sn.length > so.length) {
      return true;
    } else if (nn < no) {
      return false;
    }
  }
  if (nva.length > ova.length && 0 == nv.indexOf(ov)) {
    return true;
  }
}

/**
 * 比较资源版本大小，如果新版本资源版本号前三位与旧版本资源版本号前三位不同返回flase。
 * 前三位相同，但是新版本号最后一位比旧版本号最后一位小或者相等，返回flase，其他返回true
 * @param {String} ov
 * @param {String} nv
 * @return {Boolean}
 */
function compareResVersion(ov, nv) {
  if (!ov || !nv || ov == "" || nv == "") {
    return false;
  }
  var ovmain = ov.substring(0,ov.lastIndexOf(".")),
      nvmain = nv.substring(0,nv.lastIndexOf(".")),
      ova = ov.split(".", 4),
      nva = nv.split(".", 4);
  console.log("本地资源版本号前三位"+ovmain);
  console.log("服务器资源版本号前三位"+nvmain);
  if(ovmain!=nvmain){
    return false;
  }else{
    var so = ova[3],
        no = parseInt(so),
        sn = nva[3],
        nn = parseInt(sn);
    console.log("本地资源版本号最后一位"+no);
    console.log("服务器资源版本号最后一位"+nn);
    if(no<nn){
      return true;
    }else{
      return false;
    }
  }
}

//初始化插件
function initPlugin() {
  //插件别名
  var _LCUPDATER = 'lcUpdater';
  var B = window.plus.bridge;
  //声明函数原型
  var lcUpdater = {
    //解压
    upZipFile: function(newDirPath, successCallback, failCallback) {
      var success = typeof successCallback !== 'function' ? null : function(args) {
        successCallback(args);
      };
      var fail = typeof failCallback !== 'function' ? null : function(args) {
        failCallback(args);
      };
      callbackID = B.callbackId(success, fail);
      return B.exec(_LCUPDATER, "upZipFile", [callbackID, newDirPath]);
    },
    reStart: function(){
      callbackID = B.callbackId();
      return B.exec(_LCUPDATER, "reStart", [callbackID]);
    }
  };
  window.plus.lcUpdater = lcUpdater;
  console.log("window.plus.lcUpdater=" + JSON.stringify(window.plus.lcUpdater));
}
//解压增量包
function upzip(fileName) {
  var newFilePath = 'apps/AgricultureClient/'+fileName;
  console.log(newFilePath);
  console.log(JSON.stringify(plus.lcUpdater));
  plus.lcUpdater.upZipFile(newFilePath, function(res) {
    var isSuccess = res[0];
    console.log(isSuccess);
    if(isSuccess) {
      console.log(appVersionInfo.resourceVersion+"------------写入本地新的资源版本号")
      if(appVersionInfo.resourceForceUpdate==null?false:true){
        if("文件更新成功,重启生效！"==res[1]){
          plus.storage.setItem('up_ResourceVersion',appVersionInfo.resourceVersion);
          // plus.lcUpdater.reStart();
        }
      }else{
        plus.nativeUI.alert(res[1], function() {
          if("文件更新成功,重启生效！"==res[1]){
            plus.storage.setItem('up_ResourceVersion',appVersionInfo.resourceVersion);
            plus.lcUpdater.reStart();
          }
        });

      }
    } else {
// 					alert(res[1]);
    }
  });
}
