/**
 * Created by tian on 2018/11/20.
 * 目前只支持营业执照上传和更新
 */

var uploadtask = (function () {
    var rtrycount=0;//当前重试次数（应用程序级）
    var totaltrycount=0;//总重试次数（累计）

    function start() {
        if(!token){
            return;
        }
        var localtrycount=plus.storage.getItem("licenesetrycount");
        totaltrycount=localtrycount?localtrycount:0;
        if(totaltrycount>4) {
            //最多传4次
            return;
        }
        loopdir();
    }
    function restart() {
        rtrycount=0;
        plus.storage.setItem("licenesetrycount", 0+"");
        start();
    }

    //遍历目录，找到文件执行上传
    function loopdir() {
        //获取目录对象或文件对象
        plus.io.resolveLocalFileSystemURL("_doc/licenseimg", function(entry) {
            //创建读取目录的对象；
            var directoryReader = entry.createReader();
            //读取目录下的对象
            directoryReader.readEntries(function(entries){
                for(var i=0; i < entries.length; i++) {
                    if(entries[i].isFile){
                        upLoad(entries[i].toURL());
                    }
                    //console.log("文件：" + entries[i].toURL());
                }
            }, function (e) {
                //console.log("Read entries failed: " + e.message);
            });
        });
    }

    //删除文件
    function removeall() {
        //获取目录对象或文件对象
        plus.io.resolveLocalFileSystemURL("_doc/licenseimg", function(entry) {
            //创建读取目录的对象；
            var directoryReader = entry.createReader();
            //读取目录下的对象
            directoryReader.readEntries(function(entries){
                for(var i=0; i < entries.length; i++) {
                    if(entries[i].isFile){
                        entries[i].remove(function () {
                            console.log("文件已删除");
                        });
                    }
                    //console.log("文件：" + entries[i].toURL());
                }
            }, function (e) {
                //console.log("Read entries failed: " + e.message);
            });
        });
    }

    //上传图片
    function upLoad(file) {
        var server = xnzbUrl + '/api-image/v1/uploadFileByH5Plus';
        var task = plus.uploader.createUpload(server, {
                method: "POST"
            },
            function(res, status) { //上传完成
                console.log("status:"+status+"后台上传完成:" + JSON.stringify(res));
                if(!res.responseText) {
                    //失败，启动重试
                    rtrycount++;
                    totaltrycount++;
                    plus.storage.setItem("licenesetrycount", totaltrycount+"");
                    retry();
                    return false;
                }
                if(status == 200) {
                    var str = JSON.parse(res.responseText);
                    var imgpaths = str.data.path;
                    if(imgpaths.charAt(0)!="/"){
                        imgpaths="/"+imgpaths;
                    }
                    updateuserlicenese(imgpaths);
                    removeall();
                } else {
                    //失败，启动重试
                    rtrycount++;
                    totaltrycount++;
                    plus.storage.setItem("licenesetrycount", totaltrycount+"");
                    retry();
                }
            });
        task.addFile(file, {
            key: 'file'
        });
        task.start();
    }
    //更新用户营业执照
    function updateuserlicenese(imgpath) {
        ajax(xnzbUrl + '/api-account/updateUserLicensePicByToken', {
            data: {
                token: token,
                licensePic:imgpath
            },
            dataType: 'json',
            type: 'POST',
            timeout: 10000,
            success: function(data) {
                console.log("updateUserLicensePicByToken："+JSON.stringify(data));
            },
            error: function(xhr, type, errorThrown) {
            }
        })
    }
    //重试
    function retry() {
        var time=10000;//默认10秒
        if(rtrycount==1){
            time=10000;//10秒
        }else if(rtrycount==2){
            time=30000;//30秒
        }else if(rtrycount==3){
            time=300000;//5分钟
        }else if(rtrycount==4){
            time=3600000;//1小时
        }
        else {
            return;
        }

        setTimeout(start,time);
    }

    return{
        start:start,
        restart:restart
    }
})();

mui.plusReady(function() {
    uploadtask.start();

    //选择图片后触发
    document.addEventListener('starttask', function(event) {
        console.log("触发了重启");
        uploadtask.restart();
    });
})