/**
 * Created by tian on 2018/04/11.
 */
var selectproducetype = (function () {

	var current;//={"types":"种植","inputMode":"经营业务"};
	var t;

	function bindEvent() {
		//热门点击
		mui(".hot-content").on('tap', 'li', function () {
			document.activeElement.blur();
			//获取id
			data_detail(this.innerText, -1, '');
			mui.back();
		});
		//列表项点击
		mui(".res-nav").on('tap', '.res-item', function () {
			document.activeElement.blur();
			//获取id
			var typename = this.innerText;
			if (typename == '其它') {
				var mark = document.getElementById('mark');
				mark.style.display = "block";
				return;
			}
			var id = this.dataset.id;
			var unit = this.dataset.unit;
			data_detail(typename, id, unit);
			mui.back();
		});
		//搜索点击
		document.getElementById("btnsearch").addEventListener("tap", function () {
			var keywords = $.trim($("#txtkeywords").val());
			if (keywords.length == 0) {
				mui.toast("请输入您的经营品种");
				setTimeout(function () {
					document.getElementById('txtkeywords').focus();
				}, 500);
				return;
			}
			document.activeElement.blur();
			searchdata(keywords);
		});
		//键盘搜索点击
		document.querySelector('form').addEventListener('submit', function (e) {
			e.preventDefault(); // 阻止默认事件
			var keywords = $.trim($("#txtkeywords").val());
			if (keywords.length == 0) {
				mui.toast("请输入您的经营品种");
				document.getElementById('txtkeywords').focus();
				return;
			}
			document.activeElement.blur(); //失去焦点，隐藏键盘
			searchdata(keywords);
		});

		//关闭弹层
		document.getElementById("closemark").addEventListener("tap", function () {
			var mark = document.getElementById('mark');
			mark.style.display = "none";
		});

		//其他品种
		document.getElementById("sure").addEventListener("tap", function () {
			var confirms = $("#confirm").val();
			if (confirms == "") {
				mui.toast("请输入具体的名称");
			} else {
				data_detail("其它—" + confirms, -1, "");
				mui.back();
			}
		});

		document.getElementById("txtkeywords").addEventListener("input", function () {
			clearTimeout(t);
			var keywords = $.trim($("#txtkeywords").val());
			if (keywords.length == 0) {
				return;
			}
			t = setTimeout(function () {
				searchdata(keywords);
			}, 800)
		});
	}

	//加载热门数据
	function loadhotdata() {
		var url = "";
		if (current.inputMode == '经营业务') {
			url = xnzbUrl + '/api-report/form/getHotSpecies';
		} else if (current.inputMode == '农机类型') {
			url = xnzbUrl + '/api-report/form/getHotFarmMarchines';
		}
		if (url == "") {
			showloading(false);
			return;
		}

		ajax(url, {
			data: {
				token: token,
				farmname: current.types,
				flag: current.flag ? 1 : 0 //是否要过滤掉黑名单品种 ，主要是为了仓储申请选择品种时的过滤品种
			},
			dataType: 'json', //服务器返回json格式数据
			type: 'get', //HTTP请求类型
			success: function (data) {
				//console.log(JSON.stringify(data));
				showloading(false);
				if (data.code != 0) {
					mui.toast(data.msg);
					return;
				}
				var list = data.data.list;
				if (!list || list.length == 0) {
					return;
				}
				var html = template('js-hottemp', {list: list});
				document.getElementById('hotdata').innerHTML = html;
			},
			error: function (xhr, type, errorThrown) {
				//console.log(JSON.stringify(xhr));
				mui.toast("网络繁忙，请稍后重试！");
				showloading(false);
			}
		})
	}

	function searchdata(keywords) {
		showloading(true);
		var url = "";
		if (current.inputMode == '经营业务') {
			url = xnzbUrl + '/api-report/agriProdType/findByParent.json';
		} else if (current.inputMode == '农机类型') {
			url = xnzbUrl + '/api-report/farmMarchine/getFarmMarchines';
		}
		if (url == "") {
			showloading(false);
			return;
		}
		var d = {
			token: token,
			industryType: current.types,
			optionValues: current.inputMode,
			parent: '',
			name: keywords,
			flag: current.flag ? 1 : 0 //是否要过滤掉黑名单品种 ，主要是为了仓储申请选择品种时的过滤品种
		};
		//console.log(JSON.stringify(d));
		ajax(url, {
			data: d,
			dataType: 'json', //服务器返回json格式数据
			type: 'get', //HTTP请求类型
			success: function (data) {
				//console.log(JSON.stringify(data));
				showloading(false);
				if (data.code != 0) {
					mui.toast(data.msg);
					return;
				}
				var list = data.data.list;
				if (!list || list.length == 0) {
					// $("#sdata").hide();
					// $("#nodata").show();
					// return;
					//搜不到则显示其他
					list = [{name: '其它', id: -1}];
				}
				var html = template('js-restemp', {list: list});
				document.getElementById('sdata').innerHTML = html;
				$("#nodata").hide();
				$("#sdata").show();
			},
			error: function (xhr, type, errorThrown) {
				//console.log(JSON.stringify(xhr));
				mui.toast("网络繁忙，请稍后重试！");
				showloading(false);
			}
		})
	}

	function data_detail(subType, id, unit) {
		var updateCoop = plus.webview.getWebviewById("updateCoop");
		var JZwebview = plus.webview.getWebviewById("expenditureRecord");
		var directDataEditing = plus.webview.getWebviewById("directDataEditing");
		var updateInsuranceNew = plus.webview.getWebviewById("updateInsuranceNew");
		var addsale = plus.webview.getWebviewById("addsale");
		var createsubjectOne = plus.webview.getWebviewById("createsubjectOne");
		var coldapply = plus.webview.getWebviewById("coldapply");
		mui.fire(updateCoop, 'updateCoop', {
			subType: subType,
			getId: current.getId,
			unit: unit
		});
		mui.fire(JZwebview, 'JZwebview', {
			subType: subType,
			getId: current.getId,
			unit: unit
		});
		mui.fire(directDataEditing, 'directDataEditing', {
			subType: subType,
			getId: current.getId,
			unit: unit
		});
		mui.fire(updateInsuranceNew, 'updateInsuranceNew', {
			subType: subType,
			getId: current.getId,
			unit: unit
		});
		mui.fire(addsale, 'updateCoop', {
			subType: subType,
			id: id,
			unit: unit
		});
		mui.fire(createsubjectOne, 'updateCoop', {
			subType: subType,
			id: id,
			unit: unit
		});
		mui.fire(coldapply, 'updateCoop', {
			subType: subType,
			id: id,
			unit: unit
		});
	}


	function showloading(isshow) {
		if (isshow) {
			document.getElementById("js-loadingbg").style.display = '';
		} else {
			document.getElementById("js-loadingbg").style.display = 'none';
		}
	}

	function init() {
		current = plus.webview.currentWebview();
		showloading(true);
		loadhotdata();
		bindEvent();
	}

	return {
		init: init
	}
})();

mui.plusReady(function() {
	mui.init();
	selectproducetype.init();
});
