mui.init({
	beforeback: function() {
		var directReportLook = plus.webview.getWebviewById('directReportLook');
		var directReportHistoryFor = plus.webview.getWebviewById('directReportHistoryFor');
		mui.fire(directReportLook, 'reload', {
			reload: 1
		});
		mui.fire(directReportHistoryFor, 'reload', {
			reload: 1
		});
		return true;
	}
});
var particularYear, numId, money, time;
var vm = new Vue({
	el: "#muiContent",
	data: {
		getJson: [],
		judge: "",
		timestamp:"",
		unitMap:[]
	},
	filters: {
		formatPrice: function(num) {
			return(Number(num).toFixed(2) + '').replace(/\d{1,3}(?=(\d{3})+(\.\d*)?$)/g, '$&,');
		}
	},
	methods: {
		addRecord: function(num) {
			if(num == 1) {
				mui.openWindow({
					url: 'updateInsuranceNew.html',
					id: "updateInsuranceNew",
					styles: {
						top: 0,
						bottom: 0
					},
					extras: {
						insuranceId: numId.insuranceId
					}
				});
			} else {
				mui.openWindow({
					url: 'updateLoanNew.html',
					id: "updateLoanNew",
					styles: {
						top: 0,
						bottom: 0
					},
					extras: {
						insuranceId: numId.insuranceId
					}
				});
			}

		},
		addInformation: function(id, num) {
			if(num == 1) {
				mui.openWindow({
					url: 'updateInsurancePay.html',
					id: "disasterType",
					styles: {
						top: 0,
						bottom: 0
					},
					extras: {
						name: {
							numId: numId.insuranceId,
							insuranceId: id
						}
					}
				});
			} else {
				mui.openWindow({
					url: 'updateLoanPay.html',
					id: "updateLoanPay",
					styles: {
						top: 0,
						bottom: 0
					},
					extras: {
						name: {
							numId: numId.insuranceId,
							insuranceId: id,
							money: money
						}
					}
				});
			}

		}
	}
});
mui.plusReady(function() {
	document.addEventListener('reload', function(event) {
		var reload = event.detail.reload;
		if(reload == 1) {
			getMOnthData();
		}
	});
	numId = plus.webview.currentWebview();
	console.log(numId)
	particularYear = numId.insuranceId.time.particularYear;
	vm.judge = numId.insuranceId.uesrName;
	getMOnthData();
	function getMOnthData() {
		if(numId.insuranceId.uesrName == "保险信息") {
			ajax(xnzbUrl + "/api-report/form/getPayInsurance.json", {
				data: {
					token: token,
					category: 2,
					dynamicFormId: numId.insuranceId.getId,
					pageNo: 1,
					pageSize: 5,
					year: particularYear
				},
				dataType: 'json', //服务器返回json格式数据
				type: 'GET', //HTTP请求类型
				success: function(data) {
					muiTitle.innerHTML =numId.insuranceId.uesrName;
					vm.getJson = data.data.list;
					vm.unitMap=unitName(data.data);
				},
				error: function(xhr, type, errorThrown) {
					mui.toast("网络繁忙，请稍后重试！");
				}
			});
		} 
		if(numId.insuranceId.uesrName == "贷款信息"){
			ajax(xnzbUrl + "/api-report/form/getCreditAndRepay.json", {
				data: {
					token: token,
					category: 2,
					dynamicFormId: numId.insuranceId.getId,
					pageNo: 1,
					pageSize: 5,
					year: particularYear
				},
				dataType: 'json', //服务器返回json格式数据
				type: 'GET', //HTTP请求类型
				success: function(data) {
					muiTitle.innerHTML = numId.insuranceId.uesrName;
					vm.getJson = data.data.list;
					var list = data.data.list;
					vm.unitMap=unitName(data.data);
					for(var i = 0; i < list.length; i++) {
						var getJson = list[i].json;
						if(getJson['获贷金额'] == "") {
							return false;
						} else {
							money = getJson['获贷金额'];
						}
						var repays = list[i].repays;
						for(var j = 0; j < repays.length; j++) {
							time = repays[j].createTime;
							vm.timestamp=nowtime(time);
						}
					}
				},
				error: function(xhr, type, errorThrown) {
					mui.toast("网络繁忙，请稍后重试！");
				}
			});
		}
	}
});
function nowtime(time){//将当前时间转换成yyyymmdd格式
    var mydate = new Date(time);
    var str = "" + mydate.getFullYear();
    var mm = mydate.getMonth()+1
    if(mydate.getMonth()>9){
     str += "-"+mm;
    }
    else{
     str += "-"+"0" + mm;
    }
    if(mydate.getDate()>9){
     str += "-"+mydate.getDate();
    }
    else{
     str += "-"+"0" + mydate.getDate();
    }
    return str;
}
function unitName(dataList){
	var unitNameMap={};
	$.each(dataList.fields,function(key,value){
		if(value.inputMode==5){
			unitNameMap[value.fieldsName]=value.unitName;
		}
	})
	return unitNameMap;
}