/**
 * Created by tian on 2018/07/25
 */

var trainingapplyone = (function () {

    var currentWebview;
	var isok=false;//标志是否需要隐藏加载状态
    var ssdata;//省市区级联数据
    var nationdata=[];//民族数据
    var educationdata=[];//文化成都数据
    var politicaldata=[];//政治面貌数据
    var userid;//用户id
    var farmer;//主体法人
    var contact;//主体联系方式
    var idnum;//主体法人身份证号码
    var ishzs=0;//主体类型

    function bindEvent() {
		//性别选择点击
        document.getElementById("choosesex").addEventListener("tap",function () {
            document.activeElement.blur();
            var picker = new mui.PopPicker({
                layer: 1
            });
            var sexdata=[{value:'1',text:'男'},{value:'2',text:'女'}];
            picker.setData(sexdata);
            picker.show(function(selectItems) {
                var sexvalue=selectItems[0].value;
                var sextext=selectItems[0].text;
                $("#sex").text(sextext);
                $("#sex").data("sid",sexvalue);
            });
        });

        //生日选择
        document.getElementById("choosebirthday").addEventListener("tap",function () {
            document.activeElement.blur();
            var dtpicker = new mui.DtPicker({
                type: "date",//设置日历初始视图模式
                beginDate: new Date(1900, 0, 1),//设置开始日期
                endDate: new Date(),//设置结束日期
            });
            dtpicker.show(function(items) {
                /* * items.value 拼合后的 value
                 * items.text 拼合后的 text
                 * items.y 年，可以通过 rs.y.vaue 和 rs.y.text 获取值和文本
                 * items.m 月，用法同年
                 * items.d 日，用法同年
                 * items.h 时，用法同年
                 * items.i 分（minutes 的第二个字母），用法同年
                 */
                $("#birthday").text(items.text);
                $("#birthday").data("date",items.value);
            });
        });

        //民族选择
        document.getElementById("choosenation").addEventListener("tap",function () {
            document.activeElement.blur();
            if(!nationdata||nationdata.length<=0){
                mui.toast("民族数据获取失败，请返回重试");
                return;
            }
            var picker = new mui.PopPicker({
                layer: 1
            });
            picker.setData(nationdata);
            picker.show(function(selectItems) {
                var selvalue=selectItems[0].value;
                var seltext=selectItems[0].text;
                $("#nation").text(seltext);
                $("#nation").data("code",selvalue);
            })
        });

        //文化程度选择
        document.getElementById("chooseeducation").addEventListener("tap",function () {
            document.activeElement.blur();
            if(!educationdata||educationdata.length<=0){
                mui.toast("文化程度数据获取失败，请返回重试");
                return;
            }
            var picker = new mui.PopPicker({
                layer: 1
            });
            picker.setData(educationdata);
            picker.show(function(selectItems) {
                var selvalue=selectItems[0].value;
                var seltext=selectItems[0].text;
                $("#education").text(seltext);
                $("#education").data("code",selvalue);
            })
        });

        //政治面貌选择
        document.getElementById("choosepolitical").addEventListener("tap",function () {
            document.activeElement.blur();
            if(!politicaldata||politicaldata.length<=0){
                mui.toast("政治面貌数据获取失败，请返回重试");
                return;
            }
            var picker = new mui.PopPicker({
                layer: 1
            });
            picker.setData(politicaldata);
            picker.show(function(selectItems) {
                var selvalue=selectItems[0].value;
                var seltext=selectItems[0].text;
                $("#political").text(seltext);
                $("#political").data("code",selvalue);
            })
        });

        //地区选择
        document.getElementById("chooseaddr").addEventListener("tap",function () {
            document.activeElement.blur();
            if(!ssdata){
                mui.toast("地区数据获取失败，请返回重试");
                return;
            }
            var picker = new mui.PopPicker({
                layer: 3
            });
            picker.setData(ssdata);
            picker.show(function(selectItems) {
                var pcode=selectItems[0].text;
                var ccode=selectItems[1].text;
                var dcode=selectItems[2].text;
                var areaname= pcode+" "+ ccode+" "+ dcode;
                $("#address").text(areaname);
                $("#address").data("pcode",pcode);
                $("#address").data("ccode",ccode);
                $("#address").data("dcode",dcode);
            })
        });

        //下一步按钮
        document.getElementById("btnnext").addEventListener("tap",function () {
            document.activeElement.blur();
            if(userid<=0){
                mui.toast("获取用户信息失败，请稍后重试");
                return;
            }
            var sex=$("#sex").data("sid");//性别
            var birthday=$("#birthday").data("date");//生日
            var nation=$("#nation").data("code");//民族
            var education=$("#education").data("code");//文化程度
            var political=$("#political").data("code");//政治面貌
            var pcode= $("#address").data("pcode");//省
            var ccode= $("#address").data("ccode");//市
            var dcode= $("#address").data("dcode");//区

            if(sex==""||sex==0){
                mui.toast("请选择性别");
                return;
            }
            if(birthday==""){
                mui.toast("请选择生日");
                return;
            }
            if(nation==""){
                mui.toast("请选择民族");
                return;
            }
            if(education==""){
                mui.toast("请选择文化程度");
                return;
            }
            if(political==""){
                mui.toast("请选择政治面貌");
                return;
            }
            if(!pcode||!ccode||!dcode){
                mui.toast("请选择所在地区");
                return;
            }
            var postdata={
                userid:userid,
                farmer:farmer,
                contact:contact,
                identityNumber:idnum,
                sex:sex,
                userbirthday:birthday,
                nationality:nation,
                education:education,
                politicalstatus:political,
                farmertype:ishzs,
                province:pcode,
                city:ccode,
                region:dcode,
                address:'',
            };
            window.showLoadedPage({
                url: 'trainingApplyTwo.html',
                id: 'trainingApplyTwo',
                extras:{postdata:postdata},
                styles: {
                    top: 0,
                    bottom: 0
                },
                delay:500
            });
        });
    }
    /**
     * 加载数据
     */
    function loaddata() {
        loadareainfo();
        loadnationdata();
        loadeducationdata();
        loadpoliticaldata();
    }

    function nulltoempty(val) {
        if(val==undefined||val==null||val=='null'||val=="Null"){
            return "";
        }
        return val;
    }

    //加载民族数据
    function loadnationdata() {
        var url = prUrl+"trainapplication/gettrainingtype?type=2";
        mui.ajax(url, {
            data: {},
            dataType: 'json',
            type: 'get',
            timeout: 10000,
            success: function(data) {
                for(var i=0;i<data.length;i++){
                    nationdata.push({text:data[i].value,value:data[i].status});
                }
            },
            error: function(xhr, type, errorThrown) {
            }
        });
    }
    //加载文化程度数据
    function loadeducationdata() {
        var url = prUrl+"trainapplication/gettrainingtype?type=1";
        mui.ajax(url, {
            data: {},
            dataType: 'json',
            type: 'get',
            timeout: 10000,
            success: function(data) {
                for(var i=0;i<data.length;i++){
                    educationdata.push({text:data[i].value,value:data[i].status});
                }
            },
            error: function(xhr, type, errorThrown) {
            }
        });
    }
    //加载政治面貌数据
    function loadpoliticaldata() {
        var url = prUrl+"trainapplication/gettrainingtype?type=3";
        mui.ajax(url, {
            data: {},
            dataType: 'json',
            type: 'get',
            timeout: 10000,
            success: function(data) {
                for(var i=0;i<data.length;i++){
                    politicaldata.push({text:data[i].value,value:data[i].status});
                }
            },
            error: function(xhr, type, errorThrown) {
            }
        });
    }
    /**
     * 加载省市级联
     */
    function loadareainfo() {
        var url = prUrl+"trainapplication/gettrainingarea";
        mui.ajax(url, {
            data: {},
            dataType: 'json',
            type: 'get',
            timeout: 10000,
            success: function(data) {
                ssdata=data.data;
            },
            error: function(xhr, type, errorThrown) {
                //mui.toast("网络繁忙，请稍后重试！");
            }
        });
    }

    function checkuser() {
        var token = plus.storage.getItem("token");
        if (!!!token) {
            mui.toast("请先登录后申请");
            currentWebview.close();
            return;
        }
        //根据token获取用户权限
        var url = xnzbUrl+"/api-account/getUserByToken?token="+token;
        mui.ajax(url, {
            data: {},
            dataType: 'json',
            type: 'get',
            timeout: 10000,
            //headers: {"Authorization": "Bearer " + token},
            success: function (d) {
                //最新返回值：{"code":0,"msg":"","data":{"farmName":null,"city":null,"photo":null,"isHzs":null,"isAuthed":"0","userId":256552,"score":0,"province":"其它",
                // "contact":"15051581257","district":null,"farmer":null,"addr":null,"idNum":null,"uniqueId":null},"timestamp":1500441862286}
                if (d.code != 0) {
                    //获取失败
                    mui.toast("获取用户信息失败，请稍后重试");
                    currentWebview.close();
                    return;
                }
                var user = d.data;//用户对象
                if (user.isAuthed != 7) {
                    mui.toast("您的主体信息未通过认证，暂不能发起申请");
                    currentWebview.close();
                    return;
                }
                userid = user.userId;
                farmer = user.farmer;
                contact = user.contact;
                idnum=user.idNum;
                ishzs=user.isHzs;
                if(farmer==null||farmer==""){
                    mui.toast("请先完善主体法人信息");
                    currentWebview.close();
                    return;
                }
                $("#txtname").val(farmer);
                $("#txtidnum").val(idnum);
                $("#txtmobile").val(contact);
                loaddata();
            },
            error: function (xhr, type, errorThrown) {
                mui.toast("网络繁忙，请稍后重试！");
            }
        });
    }

    function init() {
    	mui.init();
        currentWebview = plus.webview.currentWebview();
        checkuser();
        bindEvent();
    }

    return {
        init: init
    }
})();

mui.plusReady(function() {
    trainingapplyone.init();
});
