/**
 * Created by tian on 2018/07/25
 */

var trainingapplythree = (function () {

    var currentWebview;
    var postdata;
    var ssdata;//省市区数据
    var industrytypedata=[];//产业类型数据
    var industydata=[];//产业数据
    var canclick=true;//控制提交按钮点击次数。

    function bindEvent() {

        //地区选择
        document.getElementById("chooseaddr").addEventListener("tap",function () {
            document.activeElement.blur();
            if(!ssdata){
                mui.toast("地区数据获取失败，请返回重试");
                return;
            }
            var picker = new mui.PopPicker({
                layer: 3
            });
            picker.setData(ssdata);
            picker.show(function(selectItems) {
                var pcode=selectItems[0].text;
                var ccode=selectItems[1].text;
                var dcode=selectItems[2].text;
                var areaname= pcode+" "+ ccode+" "+ dcode;
                $("#address").text(areaname);
                $("#address").data("pcode",pcode);
                $("#address").data("ccode",ccode);
                $("#address").data("dcode",dcode);
            })
        });

        //产业类型点击
        document.getElementById("chooseindustrytype").addEventListener("tap",function () {
            document.activeElement.blur();
            if(!industrytypedata||industrytypedata.length<=0){
                mui.toast("产业类型数据获取失败，请返回重试");
                return;
            }
            var picker = new mui.PopPicker({
                layer: 1
            });
            picker.setData(industrytypedata);
            picker.show(function(selectItems) {
                var selvalue=selectItems[0].value;
                var seltext=selectItems[0].text;
                $("#industrytype").text(seltext);
                $("#industrytype").data("code",selvalue);
                //刷新产业数据
                industydata=[];
                loadindustydata(selvalue);
                $("#industry").data("code","");
                $("#industry").text("请选择");
            })
        });
        //产业点击
        document.getElementById("chooseindustry").addEventListener("tap",function () {
            document.activeElement.blur();
            var picker = new mui.PopPicker({
                layer: 1
            });
            if(!industydata||industydata.length<=0){
                var typeid= $("#industrytype").data("code");//选择的产业类型id
                if(!typeid){
                    mui.toast("请先选择产业类型");
                    return;
                }
            }
            picker.setData(industydata);
            picker.show(function(selectItems) {
                var selvalue=selectItems[0].value;
                var seltext=selectItems[0].text;
                $("#industry").text(seltext);
                if(selvalue.indexOf('_')>0){
                    //由于将单位也存储在value里了，所以要判断下。
                    var selvaluearr=selvalue.split('_');
                    $("#industry").data("code",selvaluearr[0]);
                    if(selvaluearr[1]){
                        $("#industryunit").val(selvaluearr[1]);//自动填写单位，不能修改
                        $("#industryunit").attr("readonly","readonly");
                    }
                    else {
                        $("#industryunit").val('');
                        $("#industryunit").removeAttr("readonly");
                    }
                }else {
                    $("#industry").data("code",selvalue);
                    $("#industryunit").val('');
                    $("#industryunit").removeAttr("readonly");
                }
            });
        });

        //下一步按钮
        document.getElementById("btnsubmit").addEventListener("tap",function () {
            document.activeElement.blur();
            if(!canclick){
                return;
            }
            var pcode = $("#address").data("pcode");//省
            var ccode = $("#address").data("ccode");//市
            var dcode = $("#address").data("dcode");//区
            var industrytype = $("#industrytype").data("code");//产业类型id
            var industry = $("#industry").data("code");//产业id
            var industryscale = $.trim($("#industryscale").val());//产业规模
            var industryunit = $.trim($("#industryunit").val());//产业规模单位
            var industryyear = $.trim($("#industryyear").val());//产业从事年限
            var lastYearIncome = $.trim($("#lastYearIncome").val());//上年度产业收入

            if(!pcode||!ccode||!dcode){
                mui.toast("请选择产业所在地区");
                return;
            }
            if (!industrytype) {
                mui.toast("请选择产业类型");
                return;
            }
            if (!industry) {
                mui.toast("请选择产业");
                return;
            }
            if (!industryscale||industryscale<=0) {
                mui.toast("请正确输入产业规模");
                return;
            }
            if (!industryunit) {
                mui.toast("请输入产业规模单位");
                return;
            }
            if (!industryyear||industryyear<=0) {
                mui.toast("请正确输入产业从事年限");
                return;
            }
            if (!lastYearIncome||lastYearIncome<=0) {
                mui.toast("请正确输入上年度产业收入");
                return;
            }
            postdata["industryprovince"] = pcode;
            postdata["industrycity"] = ccode;
            postdata["industryregion"] = dcode;
            postdata["industrytypeid"] = industrytype;
            postdata["industryid"] = industry;
            postdata["industryscale"] = industryscale;
            postdata["industryunit"] = industryunit;
            postdata["industryexperience"] = industryyear;
            postdata["lastyearincome"] = lastYearIncome;

            canclick=false;
            var url = prUrl+"trainapplication/add";
            //var url = "http://192.168.199.203:8989/trainapplication/add";
            plus.nativeUI.showWaiting();
            mui.ajax(url, {
                data: postdata,
                dataType: 'json',
                type: 'post',
                //contentType: "application/json",
                timeout: 30000,
                success: function(data) {
                    canclick=true;
                    if(data.code=="success"){
                        plus.nativeUI.closeWaiting();
                        mui.toast("您的申请已提交，请等待排课..");
                        mui.openWindow({
                            url :'mytranclasslist.html',
                            id:'mytranclasslist'
                        });
                        setTimeout(function () {
                            var apply1 = plus.webview.getWebviewById("trainingApplyOne");
                            var apply2 = plus.webview.getWebviewById("trainingApplyTwo");
                            if (!!apply1) {
                                apply1.close("none");
                            }
                            if (!!apply2) {
                                apply2.close("none");
                            }
                            plus.webview.currentWebview().close("none");
                        },500)
                    }
                    else {
                        mui.toast(data.message);
                        canclick=true;
                        plus.nativeUI.closeWaiting();
                    }
                },
                error: function(xhr, type, errorThrown) {
                    mui.toast("网络繁忙，请稍后重试！");
                    plus.nativeUI.closeWaiting();
                    canclick=true;
                }
            });
        });
    }

    function nulltoempty(val) {
        if(val==undefined||val==null||val=='null'||val=="Null"){
            return "";
        }
        return val;
    }

    function loaddata() {
        loadareainfo();
        loadindustrytypedata();
    }
    /**
     * 加载省市级联
     */
    function loadareainfo() {
        var url = prUrl+"trainapplication/gettrainingarea";
        mui.ajax(url, {
            data: {},
            dataType: 'json',
            type: 'get',
            timeout: 10000,
            success: function(data) {
                ssdata=data.data;
            },
            error: function(xhr, type, errorThrown) {
                //mui.toast("网络繁忙，请稍后重试！");
            }
        });
    }

    //加载产业类型
    function loadindustrytypedata() {
        var url = prUrl+"trainapplication/gettrainingtype?type=5";
        mui.ajax(url, {
            data: {},
            dataType: 'json',
            type: 'get',
            timeout: 10000,
            success: function(data) {
                for(var i=0;i<data.length;i++){
                    industrytypedata.push({text:data[i].value,value:data[i].status});
                }
            },
            error: function(xhr, type, errorThrown) {
            }
        });
    }

    //加载产业类型
    function loadindustydata(typeid) {
        var url = prUrl+"trainapplication/gettrainingIndustrytype?type="+typeid;
        mui.ajax(url, {
            data: {},
            dataType: 'json',
            type: 'get',
            timeout: 10000,
            success: function(data) {
                for(var i=0;i<data.length;i++){
                    var value=data[i].code;
                    if(data[i].unit){
                        value=value+"_"+data[i].unit;//将单位也隐藏在value里，以便自动带出
                    }
                    industydata.push({text:data[i].industryname,value:value});
                }
            },
            error: function(xhr, type, errorThrown) {
            }
        });
    }

    function init() {
    	mui.init();
        currentWebview = plus.webview.currentWebview();
        postdata=currentWebview.postdata;
        loaddata();
        bindEvent();
    }
    return {
        init: init
    }
})();

mui.plusReady(function() {
    trainingapplythree.init();
});
