
var citychoose=(function () {
    var self;

    var isloadqx=0;//是否加载了当前市下的区县
    var myt;//延迟搜索控制

    var zxs=["北京市","上海市","重庆市","天津市"];

    function init() {
        self = plus.webview.currentWebview();
        loaddata();
        initcurrent();//当前城市
        initHistory();
        bindEvent();
    }

    //获取城市列表
    function loaddata() {
        ajax(xnzbUrl + '/api-account/getAreaByFirstCharacter', {
            data: {},
            dataType: 'json',
            type: 'get',
            timeout: 10000,
            success: function(data) {
                if(data.code!=0){
                    mui.toast(data.msg);
                    return;
                }
                var hotlist=data.data.hotList;
                inithostcity(hotlist);//绑定热门城市
                var citylist=data.data.data;
                initcitylist(citylist);//绑定城市列表
            },
            error: function(xhr, type, errorThrown) {
                mui.toast('网络繁忙，请稍后重试！');
            }
        });
    }

    //初始化当前正在看的城市，和GPS定位的城市
    function initcurrent() {
        //获取当前正在看的城市
        var geo_province = plus.storage.getItem('geo_province');
        var geo_city = plus.storage.getItem('geo_city');
        var geo_district = plus.storage.getItem('geo_district');

        //获取GPS定位到的城市
        var geo_province_gps = plus.storage.getItem('geo_province_gps');
        var geo_city_gps = plus.storage.getItem('geo_city_gps');
        var geo_district_gps = plus.storage.getItem('geo_district_gps');

        var showlevel= plus.storage.getItem('geo_level');//显示层级，1：省，2市，3区县
        if(showlevel==3){
            $("#currentcity").text(geo_city+" "+geo_district);//显示区县
            $("#chooseqx").text("切换区/县");
        }
        else {
            if (geo_city == '市辖区' || geo_city == '市辖县') {
                $("#currentcity").text(geo_province);
            }
            else {
                $("#currentcity").text(geo_city);
            }
        }
        $("#chooseqx").show();//可选择区县
        $("#gpscity").text(geo_city_gps?geo_city_gps:"定位失败");
    }
    
    //读取历史访问城市列表（3个）
    function initHistory() {  // 历史记录渲染
        var cityhistory = plus.storage.getItem('cityhistory');
        if (!cityhistory) {
            $("#historybox").hide();
            return;
        }
        var historylist = JSON.parse(cityhistory);
        var historyhtml = '';
        $.each(historylist, function (i, item) {
            historyhtml += '<div class="cityname" pname="'+item.provinceName+'">' + item.cityname + '</div>';
        })
        $('#historylist').html(historyhtml);
    }

    //绑定事件
    function bindEvent() {
        // 历史城市点击
        mui('#historylist').on('tap', '.cityname', function () {
            document.activeElement.blur();
            var cityname = $(this).text();
            var provincename=$(this).attr("pname");
            switchcity(provincename,cityname,"");
        });
        // 热门城市点击
        mui('#hotlist').on('tap', '.cityname', function () {
            document.activeElement.blur();
            var cityname = $(this).text();
            var provincename=$(this).attr("pname");
            switchcity(provincename,cityname,"");
        });
        //城市列表点击
        mui('#citylist').on('tap', 'p', function () {
            document.activeElement.blur();
            var cityname = $(this).text();
            var provincename=$(this).attr("pname");
            switchcity(provincename,cityname,"");
        });
        //选择区县
        document.getElementById("chooseqx").addEventListener("tap",function () {
            document.activeElement.blur();
            if(isloadqx==1){
                //已加载过区县的数据
                $("#chooseqx").toggleClass("qxup");
                $("#qxbox").slideToggle();
                return;
            }
            var geo_city = plus.storage.getItem('geo_city');
            if (geo_city == '市辖区' || geo_city == '市辖县') {
                geo_city = plus.storage.getItem('geo_province');
            }
            if(!geo_city){
                return;
            }
            $("#chooseqx").toggleClass("qxup");
            $("#qxbox").slideToggle();
            ajax(xnzbUrl + '/api-account/getAreaByParentId', {
                data: {
                    areaName:geo_city
                },
                dataType: 'json',
                type: 'get',
                timeout: 10000,
                success: function(data) {
                    if(data.code!=0){
                        mui.toast(data.msg);
                        return;
                    }
                    var qxlist=data.data.data;
                    var qxhtml='';
                    $.each(qxlist,function (i, item) {
                        qxhtml += '<div class="cityname" cid="'+item.id+'" pid="'+item.parentId+'" pname="'+item.provinceName+'">' + item.areaName + '</div>';
                    });
                    $("#qxlist").html(qxhtml);
                    isloadqx=1;
                },
                error: function(xhr, type, errorThrown) {
                    mui.toast('网络繁忙，请稍后重试！');
                }
            });
        });
        //区县点击
        mui('#qxlist').on('tap', '.cityname', function () {
            document.activeElement.blur();
            var geo_province = plus.storage.getItem('geo_province');
            var geo_city = plus.storage.getItem('geo_city');
            var district = $(this).text();
            switchcity(geo_province,geo_city,district);
        });
        //搜索
        document.getElementById("txtsearch").addEventListener("input",function () {
            clearTimeout(myt);
            var keywords=$("#txtsearch").val();
            if(keywords==""){
                $(".searchbox").hide();
                $(".letter").show();
                $(".citybox").show();
                return;
            }
            //延迟半秒执行搜索
            myt= setTimeout(function () {
                $("#resultlist").html("");
                $(".nodata").hide();
                ajax(xnzbUrl + '/api-account/getAreaByName', {
                    data: {
                        name:keywords
                    },
                    dataType: 'json',
                    type: 'get',
                    timeout: 10000,
                    success: function(data) {
                        if(data.code!=0){
                            mui.toast(data.msg);
                            return;
                        }
                        var reslist=data.data.data;
                        if(reslist.length>0){
                            var reshtml="";
                            $.each(reslist,function (i,item) {
                                var level=item.level;
                                if(level==1){
                                    //搜到的是市
                                    reshtml += '<p level="1" cid="'+item.id+'" pid="'+item.parentId+'" pname="'+item.provinceName+'" cname="'+item.cityName+'" dname="">' + item.areaName + '</p>';
                                }
                                else if(level==2) {
                                    if (zxs.indexOf(item.provinceName) > -1) {
                                        //搜到的是 直辖市里的区，则城市名应该去省名
                                        reshtml += '<p level="2" cid="' + item.id + '" pid="' + item.parentId + '" pname="' + item.provinceName + '" cname="' + item.provinceName + '" dname="' + item.areaName + '">' + item.areaName + '，' + item.provinceName + '</p>';
                                    }
                                    else {
                                        //搜到的是区县
                                        reshtml += '<p level="2" cid="' + item.id + '" pid="' + item.parentId + '" pname="' + item.provinceName + '" cname="' + item.cityName + '" dname="' + item.areaName + '">' + item.areaName + '，' + item.cityName + '</p>';
                                    }
                                }
                                else if(level==0){
                                    if(zxs.indexOf(item.areaName)>-1) {
                                        //搜到的是直辖市
                                        reshtml += '<p level="1" cid="'+item.id+'" pid="'+item.parentId+'" pname="'+item.provinceName+'" cname="'+item.areaName+'" dname="'+item.areaName+'">' + item.areaName+ '</p>';
                                    }
                                }
                            });
                            $("#resultlist").html(reshtml);
                            $(".searchbox").show();
                            $(".letter").hide();
                            $(".citybox").hide();
                        }
                        else {
                            //未搜到
                            $(".searchbox").show();
                            $(".letter").hide();
                            $(".citybox").hide();
                            $(".nodata").show();//显示无结果
                        }
                    },
                    error: function(xhr, type, errorThrown) {
                        mui.toast('网络繁忙，请稍后重试！');
                    }
                });
            },500);
        })
        //搜索结果点击
        mui('#resultlist').on('tap', 'p', function () {
            document.activeElement.blur();
            var level=$(this).attr("level");
            //var areaname = $(this).text();
            var provincename=$(this).attr("pname");
            var cityname=$(this).attr("cname");
            var discritname=$(this).attr("dname");
            // if(level==1){
            //     //市
            //     switchcity(provincename,areaname,"");
            // }
            // else if(level==2) {
            //     //区县
            //     var cityname = $(this).attr("cname");
            // }
            switchcity(provincename, cityname, discritname);
        });
        //输入框点击×
        document.querySelector(".mui-icon-clear").addEventListener("tap",function () {
            $(".searchbox").hide();
            $(".letter").show();
            $(".citybox").show();
        });
        //点击GPS定位的城市
        document.getElementById("location_gps").addEventListener("tap",function () {
            var provice_gps= plus.storage.getItem('geo_province_gps');
            var city_gps= plus.storage.getItem('geo_city_gps');
            //var district_gps= plus.storage.getItem('geo_district_gps');
            if(provice_gps){
                switchcity(provice_gps,city_gps,"");
            }
            else {
                mui.toast("定位失败，请检查应用定位权限");
            }
        });

        //重新定位
        document.getElementById("relocation").addEventListener("tap",function () {
            event.stopPropagation();
            $("#relocation").text("正在定位");
            plus.geolocation.getCurrentPosition(geoInf, function (e) {
                //获取设备位置信息失败回调函数
                console.log(JSON.stringify(e));
                $("#relocation").text("重新定位");
                mui.toast("定位失败，请检查应用定位权限");
            }, {
                geocode: true
            });
        });

        //字母导航事件
        (function ($) {
            $('.letter').bind("touchstart touchmove", function (e) {
                var top = $(window).scrollTop();
                e.preventDefault();//阻止默认滚动
                var touch = e.touches[0];
                var ele = document.elementFromPoint(touch.pageX, touch.pageY - top);
                if(ele==null){
                    return;
                }

                if (ele.tagName === 'A') {
                    var s = $(ele).text();
                    $(window).scrollTop($('#' + s + '1').offset().top-64);
                    $("#showLetter span").html(s.substring(0, 1));
                    $("#showLetter").show();
                }
            });

            $('.letter').bind("touchend", function (e) {
                $("#showLetter").hide(500);
            });
        })(Zepto);
    }
    function geoInf(position) {
        if(plus.os.name == "iOS") {
            getAddress(position.coords.longitude + "," + position.coords.latitude);
        } else {
            var province_now=position.address.province;
            var city_now=position.address.city;
            var district_now=position.address.district;

            //存储当前位置(GPS获取到的)，geo_province存储的是获取数据的城市（可自行切换）， geo_province_now只存储当前定位的城市，
            plus.storage.setItem('geo_province_gps', province_now);
            plus.storage.setItem('geo_city_gps', city_now);
            plus.storage.setItem('geo_district_gps', district_now);
            //mui.toast(province_now+" "+city_now+" "+district_now);
            $("#gpscity").text(city_now?city_now:"定位失败");
            $("#relocation").text("重新定位");
        }
    }
    function getAddress(point) {
        ajax('http://restapi.amap.com/v3/geocode/regeo', {
            data: {
                location: point,
                key: '3fc3b060a51c626c6f78da9c220dabf9'
            },
            dataType: 'json',
            type: 'get',
            timeout: 10000,
            success: function(data) {
                var province_now=data.regeocode.addressComponent.province;
                var city_now=data.regeocode.addressComponent.city;
                var district_now=data.regeocode.addressComponent.district;

                //存储当前位置(GPS获取到的)，geo_province存储的是获取数据的城市（可自行切换）， geo_province_now只存储当前定位的城市，
                plus.storage.setItem('geo_province_gps', province_now);
                plus.storage.setItem('geo_city_gps', city_now);
                plus.storage.setItem('geo_district_gps', district_now);
                //mui.toast(province_now+" "+city_now+" "+district_now);
                $("#gpscity").text(city_now?city_now:"定位失败");
                $("#relocation").text("重新定位");
            },
            error: function(xhr, type, errorThrown) {
                $("#relocation").text("重新定位");
                mui.toast("定位失败，请检查应用定位权限");
            }
        })
    }
    //初始化热门城市
    function inithostcity(hotlist) {
        var hotHtml = '';
        $.each(hotlist, function (i, item) {
            hotHtml += '<div class="cityname" cid="'+item.id+'" pid="'+item.parentId+'" pname="'+item.provinceName+'">' + item.areaName + '</div>';
        });
        $("#hotlist").html(hotHtml);
    }
    //初始化城市列表
    function initcitylist(citylist) {
        $('.city').html('');
        var html = '';
        $.each(citylist, function (i, item) {
            if(item.cityList.length>0) {
                html += '<div class="city-list"><span class="city-letter" id="' + item.character + '1">' + item.character + '</span>';
                $.each(item.cityList, function (j, data) {
                    html += '<p cid="'+data.id+'" pid="'+data.parentId+'" pname="'+data.provinceName+'">' + data.areaName + '</p>';
                })
                html += '</div>';
            }
        })
        $('.city').append(html);
    }

    //切换城市
    function switchcity(province, city, district) {
        //mui.toast(province+ " "+city+" "+district);
        //存储获取数据的城市
        plus.storage.setItem('geo_province', province);
        plus.storage.setItem('geo_city', city);
        plus.storage.setItem('geo_district', district);
        if(district){
            plus.storage.setItem('geo_level',"3");//显示层级，1：省，2市，3区县
        }
        else {
            plus.storage.setItem('geo_level',"2");//显示层级，默认显示市级
        }

        var dingwei = plus.webview.getWebviewById('sub_index');
        mui.fire(dingwei, 'position', {
            Isposition: 0
        });
        self.close();

    }

    return{
        init:init
    }
})();

mui.plusReady(function() {
    citychoose.init();
})

  