/**
 * add by tianchao 2018-8-30
 * @type {{init}}
 */
var mynewslist = (function () {
    var pageNo=1;//当前页
    var pageSize=10;//每页条数
    var newtype=5;//消息类型，默认通知 1、贷款；2、保险；6、社会化服务；5、通知
    var self;

    var newlist=new Vue({
        el: '#datalist',
        data: {
            list:[]
        },
    });

    /**
     * 绑定时间
     */
    function bindEvent() {
        //消息类型点击
        mui("#datalist").on('tap','.item-box',function(){
            var id=this.dataset.id;//主键
            var type=this.dataset.type;//消息类型
            var contid=this.dataset.contid;//

            gopage(type,id,contid);
            readmessage(id);
            //将消息变成已读取（页面）
            var badge= this.querySelector(".badge");
            if(badge) {
                badge.parentNode.removeChild(badge);
            }
            var parent=self.parent();
            if(parent){
                parent.evalJS("mynews.loadunread()");
            }
        });
        //删除按钮点击
        mui("#datalist").on('tap','.mui-btn-red',function(){
            var id=this.dataset.id;
            var li = this.parentNode.parentNode;
            mui.confirm('确认删除该条记录？', '', ['确认', '取消'], function(e) {
                if(e.index == 0) {
                    li.parentNode.removeChild(li);
                    ajax(xnzbUrl + '/api-message/message/delete', {
                        data: {
                            id: id
                        },
                        type: 'GET',
                        dataType: 'json',
                        timeout: 10000,
                        success: function(data) {
                            //console.log(JSON.stringify(data));
                            var parent=self.parent();
                            if(parent){
                                parent.evalJS("mynews.loadunread()");
                            }
                        },
                        error: function(xhr, type, errorThrown) {
                            mui.toast('网络繁忙，请稍后重试！');
                        }
                    });
                } else {
                    setTimeout(function() {
                        mui.swipeoutClose(li);
                    }, 10);
                }
            });
        });
    }

    /**
     * 加载数据
     */
    function loaddata() {
        ajax(xnzbUrl + '/api-message/message/pageNew', {
            data: {
                token: token,
                type: newtype,
                pageSize: pageSize,
                pageNo: pageNo
            },
            dataType: 'json',
            type: 'get',
            timeout: 10000,
            success: function(data) {
                if(!data.code) {
                    var messagelist=data.data.messageList;
                    // for (var i=0;i<messagelist.length;i++){
                    //     if(messagelist[i].title.length>12){
                    //         messagelist[i].title=messagelist[i].title.substr(0,12)+"..";
                    //     }
                    // }
                    if(pageNo==1){
                        newlist.list = messagelist;
                        mui('#pullrefresh').pullRefresh().endPulldownToRefresh();
                        if(messagelist.length<=0){
                            //第一页没有数据，则显示无数据
                            document.getElementById("nodata").style.display="block";
                            mui('#pullrefresh').pullRefresh().endPullupToRefresh(true);
                        }
                        else {
                            document.getElementById("nodata").style.display="none";
                        }
                    }
                    else {
                        newlist.list = newlist.list.concat(messagelist);
                        mui('#pullrefresh').pullRefresh().endPullupToRefresh(messagelist.length<pageSize);
                    }
                    document.getElementById("loading").style.display="none";
                };
            },
            error: function(xhr, type, errorThrown) {
                mui.toast('网络繁忙，请稍后重试！');
            }
        });
    }

    /**
     * 将消息改成已读
     * @param id
     */
    function readmessage(id) {
        ajax(xnzbUrl + '/api-message/message/readMessage', {
            data: {
                token: token,
                messageId: id
            },
            dataType: 'json',
            type: 'get',
            timeout: 10000,
            success: function(data) {
                console.log(JSON.stringify(data))
            },
            error: function(xhr, type, errorThrown) {
                //mui.toast('网络繁忙，请稍后重试！');
            }
        });
    }

    /**
     * 点击跳页逻辑
     * @param type
     * @param mid
     * @param contid
     */
    function gopage(type, mid,contid) {
        if (type == 1) {
            //贷款
            var href = '../support/pages/loan/myloan.html';
            var id = 'myloan';
            window.showLoadedPage({
                url: href,
                id: id,
                styles: {
                    top: 0,
                    bottom: 0
                },
                delay: 500
            });
        } else if (type == 2) {
            //投保消息
            var href = '../support/pages/insurance/myinsurance.html';
            var id = 'myinsurance';
            window.showLoadedPage({
                url: href,
                id: id,
                styles: {
                    top: 0,
                    bottom: 0
                },
                delay: 500
            });
        } else if (type == 3) {
            //补贴消息，跳转到我的补贴页面
            var obj = {};
            var myDate = new Date(); //获取系统当前时间
            obj.particularYear = myDate.getFullYear(); //获取完整的年份
            obj.currentMonth = myDate.getMonth() + 1; //获取当前月份
            obj.currentDay = myDate.getDate(); //获取当前日(1-31)
            obj.num = 2;
            //获取当前正在看的城市(加载数据的)
            var geo_province = plus.storage.getItem('geo_province');
            var geo_city = plus.storage.getItem('geo_city');
            var geo_district = plus.storage.getItem('geo_district');

            //获取GPS定位到的城市
            var geo_province_gps = plus.storage.getItem('geo_province_gps');
            var geo_city_gps = plus.storage.getItem('geo_city_gps');
            var geo_district_gps = plus.storage.getItem('geo_district_gps');
            window.showLoadedPage({
                url: 'zfSubsidy.html',
                id: 'zfSubsidy',
                extras: {
                    province: geo_province,
                    city: geo_city,
                    district: geo_district,
                    pro: geo_province_gps,
                    cit: geo_city_gps,
                    dis: geo_district_gps,
                    time: obj
                },
                delay: 500
            });
        } else if (type == 4) {
            //积分增长通知
            mui.openWindow({
                url: '../userCenter/myIntegral.html',
                id: 'myIntegral',
                styles: {
                    top: 0,
                    bottom: 0
                }
            });
        } else if (type == 5) {
            //主体通知
            mui.openWindow({
                url: '../userCenter/mySubject.html',
                id: 'mySubject',
                styles: {
                    top: 0,
                    bottom: 0
                }
            });
        } else if (type == 6) {
            //服务消息
            window.showLoadedPage({
                url: '../support/pages/service/myservice.html',
                id: 'myservice',
                styles: {
                    top: 0,
                    bottom: 0
                },
                delay: 500
            });
        } else if (type == 100) {
            //不做任何动作
        } else if (type == 101) {
            //自定义推送消息
            var href = 'policyCustomDetail.html';
            var id = 'policyCustomDetail';
            window.showLoadedPage({
                url: href,
                id: id,
                extras: {
                    type: type,
                    mid: mid
                },
                styles: {
                    top: 0,
                    bottom: 0
                },
                delay: 500
            });
        } else if (type == 102) {
            //新闻推送消息
            var detailpage = plus.webview.getWebviewById('policyDetail');
            if (!detailpage) {
                detailpage = mui.preload({
                    url: 'policyDetail.html',
                    id: 'policyDetail',
                    styles: {
                        "render": "always", //窗口渲染模式
                        "popGesture": "hide",
                        "bounce": "vertical" //窗口遇到边框是否有反弹效果 vertical表示垂直方向反弹
                    }
                });
            }
            //触发子窗口变更新闻详情  触发自定义事件
            mui.fire(detailpage, 'get_detail', {
                detailId: contid,
                type: "",
                title: "",
                author: "",
                time: "",
                read: "",
                cover: ""
            });
            setTimeout(function () {
                detailpage.show("slide-in-right", 300);
            }, 150);
        } else if (type == 103) {
            //直报提醒推送
            var myDate = new Date(); //获取系统当前时间
            var currentYear = myDate.getFullYear(); //获取完整的年份
            var lastYear = currentYear - 1;
            var currentMonth = myDate.getMonth() + 1; //获取当前月份
            var currentDay = myDate.getDate(); //获取当前日(1-31)
            ajax(xnzbUrl + '/api-report/form/queryByCategory.json', {
                data: {
                    token: token,
                    year: lastYear,
                    category: 2
                },
                dataType: 'json',
                type: 'GET',
                timeout: 10000,
                success: function (data) {
                    //console.log(data.data.isFormData);
                    var obj = {};
                    if (data.data.isFormData == 0) {
                        obj.particularYear = lastYear;
                        obj.currentMonth = currentMonth;
                        obj.currentDay = currentDay;
                        obj.num = 1;
                    } else {
                        obj.particularYear = currentYear;
                        obj.currentMonth = currentMonth;
                        obj.currentDay = currentDay;
                        obj.num = 2;
                    }
                    window.showLoadedPage({
                        url: '../directReport/directReportLook.html',
                        id: 'directReportLook',
                        styles: {
                            top: 0,
                            bottom: 0
                        },
                        extras: {
                            time: obj
                        },
                        delay: 500
                    });
                },
                error: function (xhr, type, errorThrown) {
                    mui.toast("网络繁忙，请稍后重试！");
                }
            });
        } else if (type == 104) {
            //接受洽谈通知
            window.showLoadedPage({
                url: '../support/pages/business/mybusiness.html',
                id: 'mybusiness',
                styles: {
                    top: 0,
                    bottom: 0
                },
                delay: 500
            });
        } else if (type == 108) {
            //冷库补贴进度通知
            window.showLoadedPage({
                url: '../subsidy/mysubsidylistcangc.html',
                id: 'mysubsidylistcangc',
                styles: {
                    top: 0,
                    bottom: 0
                },
                delay: 500
            });
        }
    }
    //下拉刷新方法
    function pulldownrefresh() {
        pageNo=1;
        mui('#pullrefresh').pullRefresh().refresh(true);
        loaddata();
        setTimeout(function () {
            mui('#pullrefresh').pullRefresh().endPulldownToRefresh();
        },5000)
    }

    //加载更多
    function loadmore() {
        pageNo++;
        loaddata();
    }

    function init() {
        mui.init({
            pullRefresh : {
                container:"#pullrefresh",//下拉刷新容器标识，querySelector能定位的css选择器均可，比如：id、.class等
                down : {
                    callback :pulldownrefresh //必选，刷新函数，根据具体业务来编写，比如通过ajax从服务器获取新数据；
                },
                up : {
                    callback :loadmore //必选，刷新函数，根据具体业务来编写，比如通过ajax从服务器获取新数据；
                }
            }
        });
        bindEvent();
        loaddata();
        self = plus.webview.currentWebview();
    }

    //供父页面调用的查询方法
    function query(type) {
        newtype=type;
        pageNo=1;
        mui('#pullrefresh').pullRefresh().endPulldownToRefresh();
        mui('#pullrefresh').pullRefresh().refresh(true);
        newlist.list=[];
        document.getElementById("loading").style.display="block";
        document.getElementById("nodata").style.display="none";
        loaddata();
    }
    return{
        init:init,
        query:query
    }
})();
mui.plusReady(function() {
    mynewslist.init();
});
