mui.init();
var shares = null;
var isFavorite = '0';
var mobile='';
var vm = new Vue({
	el: '.mui-content',
	data: getDefaultData(),
	methods: {
		resetData: function() { //重置数据
			//Object.assign(this.$data, getDefaultData());
			this.$data=getDefaultData();
		}
	}
});

function getDefaultData() {
	return {
		title: '',
		author: '',
		time: '',
		read: '',
		cover: '',
		content: '',
		type: '',
		detailId: '',
		summary:''
	}
}
//监听自定义事件，获取新闻详情
document.addEventListener('get_detail', function(event) {
	var detailId = event.detail.detailId;
	if(!detailId) {
		return;
	}
	//前页传入的数据，直接渲染，无需等待ajax请求详情后
	vm.detailId = event.detail.detailId;
	vm.type = event.detail.type;
	vm.title = event.detail.title;
	vm.author = event.detail.author;
	vm.time = event.detail.time;
	vm.read = event.detail.read;
	vm.cover = event.detail.cover;
	//向服务端请求文章详情内容
	if(token){
		token=token;
	}else{
		token="";
	}
	mui.ajax(xnzbUrl + '/api-content/news/get', {
		data: {
			id: detailId,
			token: token
		},
		type: 'GET',
		dataType: 'json',
		timeout: 10000,
		success: function(data) {
			//console.log(JSON.stringify(data));
			if(!data.code) {
				var news=data.data.news;
				if(news.status!=1) {
					mui.toast("文章已删除");
					//动画结束后，恢复默认值
					setTimeout(function () {
						plus.webview.currentWebview().hide("auto", 300);
						window.scrollTo(0, 0);
						vm.resetData();
					}, 300);
					return;
				}
				vm.content = news.content;
				//console.log(data.data.news.content)
				vm.summary = news.summary;
				bindHref()
				//console.log(data.data.news.summary)
				//add by tianchao
				if(!vm.detailId){
					vm.detailId =news.id;
				}
				if(!vm.type){
					vm.type =news.type;
				}
				if(!vm.title){
					vm.title = news.title;
				}
				if(!vm.author){
					vm.author = news.source;
				}
				if(!vm.time){
					vm.time = news.createTimeStr;
				}
				if(!vm.read){
					vm.read = news.accessNum;
				}
				if(!vm.cover){
					vm.cover = news.image;
				}
				//end
			}
		},
		error: function(xhr, type, errorThrown) {
			mui.toast('网络繁忙，请稍后重试！');
		}
	});
	//判断是否收藏
	mui.ajax(xnzbUrl + '/api-content/newsFavorite/isFavorite', {
		data: {
			token: token,
			newsId: vm.detailId
		},
		type: 'GET',
		dataType: 'json',
		timeout: 10000,
		success: function(data) {
			if(!data.code) {
				isFavorite = data.data.isFavorite;
				if(isFavorite == 0) {
					muiid('shoucangImg').setAttribute('src', '../../static/img/xnzb-icon-shoucang.png');
				} else {
					muiid('shoucangImg').setAttribute('src', '../../static/img/xnzb-icon-shoucanged.png');
				}
			}
		},
		error: function(xhr, type, errorThrown) {
			mui.toast('网络繁忙，请稍后重试！');
		}
	});
});
// 绑定a 标签
function bindHref() {
	mui('#xnzb-content').on('tap', 'a', function (e) {
		e.preventDefault();
		var link = this.getAttribute('href')
		//console.log('打开浏览器的链接是', link)
		if (link) {
			//在app内部打开链接
			link=updateQueryStringParameter(link,"phone",mobile);
			window.showLoadedPage({
				url: '../support/pages/common/webbrowse.html',
				id: 'webbrowse',
				extras: {
					url: link,
				},
				delay: 500
			});
		}
	});
}
//重写返回逻辑
mui.back = function() {
	plus.webview.currentWebview().hide("auto", 300);
	//动画结束后，恢复默认值
	setTimeout(function() {
		window.scrollTo(0, 0);
		vm.resetData();
	}, 300);
}
mui.plusReady(function() {
	//	plus.navigator.setStatusBarStyle('dark');
	getusermobile();
	updateSerivces();
	/**
	 * 分享模块
	 */
	document.querySelector('#xnzbShare').addEventListener('tap', function() {
		shareHref();
	});
	//点击收藏
	document.getElementById('collection').addEventListener('tap', function() {
		if(isLogin()) {
			mui.ajax(xnzbUrl + '/api-content/newsFavorite/favorite', {
				data: {
					token: token,
					type: vm.type,
					newsId: vm.detailId
				},
				type: 'GET',
				dataType: 'json',
				timeout: 10000,
				success: function(data) {
					if(!data.code) {
						if(isFavorite == '0') {
							mui.toast('收藏成功！');
							isFavorite = '1';
							muiid('shoucangImg').setAttribute('src', '../../static/img/xnzb-icon-shoucanged.png');
						} else {
							mui.toast('已取消收藏！');
							isFavorite = '0';
							muiid('shoucangImg').setAttribute('src', '../../static/img/xnzb-icon-shoucang.png');
						}
					}
				},
				error: function(xhr, type, errorThrown) {
					mui.toast('网络繁忙，请稍后重试！');
				}
			});
		}
	});
});

function getusermobile() {
	//获取用户手机号
	if(token){
		ajax(xnzbUrl + '/api-account/getUserByToken', {
			data: {
				token: token
			},
			dataType: 'json',
			type: 'get',
			timeout: 10000,
			success: function(data) {
				if(!data.code) {
					var userData = data.data;
					mobile=userData.contact;
				}
			},
			error: function(xhr, type, errorThrown) {
			}
		});
	}
}
//更新分享服务
function updateSerivces() {
	plus.share.getServices(function(s) {
		shares = {};
		for(var i in s) {
			var t = s[i];
			shares[t.id] = t;
		}
	}, function(e) {
		mui.toast('获取分享服务列表失败：' + e.message);
	});
}
/**
 * 发送分享消息
 * @param {JSON} msg
 * @param {plus.share.ShareService} s
 */
function shareMessage(msg, s) {
	s.send(msg, function() {
		mui.toast('分享成功！');
    handleIntegral('010')
	}, function(e) {
		mui.toast('分享失败!');
	});
}
/**
 * 分享操作
 * @param {JSON} sb 分享操作对象s.s为分享通道对象(plus.share.ShareService)
 * @param {Boolean} bh 是否分享链接
 */
function shareAction(sb, bh) {
	console.log(sb)
	if(!sb || !sb.s) {
		mui.toast('无效的分享服务！');
		return;
	}
	//	var description = data.data.news.content.substring(0,100);
	var description = vm.summary;
	console.log(description)

	//	description = description.replace(html, "<[^>]*>", "");
	//description = description.replace(/[^\u4e00-\u9fa5]/gi, "");
	//description = description.replace(/微软雅黑/g, "");
	//description = description.replace(/宋体/g, "");
	if(plus.os.name == "Android") {
		if(sb.title=="QQ"){
			var msg = {
				href: shareUrl+'policyDetails.html?id=' + vm.detailId,
				thumbs: '_www/static/img/shareLogo.png',
				pictures:'_www/static/img/shareLogo.png',
				title: vm.title,
				content: description,
				extra: {
					scene: sb.x
				}
			}
		}
		else{
			var msg = {
				href: shareUrl+'policyDetails.html?id=' + vm.detailId,
				thumbs: ['_www/static/img/shareLogo.png'],
				pictures:['_www/static/img/shareLogo.png'],
				title: vm.title,
				content:description,
				extra: {
					scene: sb.x
				}
			}
		}
	} else {
		var msg = {
			href: shareUrl+'policyDetails.html?id=' + vm.detailId,
			thumbs: ['_www/static/img/shareLogo.png'],
			pictures: ['_www/static/img/shareLogo.png'],
			title: vm.title,
			content: description,
			extra: {
				scene: sb.x
			}
		}
	}
	// 发送分享
	if(sb.s.authenticated) {
		shareMessage(msg, sb.s); //已授权
	} else {
		sb.s.authorize(function() { //未授权
			shareMessage(msg, sb.s);
		}, function(e) {
			mui.toast('认证授权失败');
		});
	}
}
//分享链接
function shareHref() {
	var shareBts = [];
	// 更新分享列表
	var ss = shares['weixin'];
	ss && ss.nativeClient && (shareBts.push({
		title: '微信朋友圈',
		s: ss,
		x: 'WXSceneTimeline'
	}), shareBts.push({
		title: '微信好友',
		s: ss,
		x: 'WXSceneSession'
	}));
	ss = shares['qq'];
	ss && ss.nativeClient && shareBts.push({
		title: 'QQ',
		s: ss
	});
	// 弹出分享列表
	shareBts.length > 0 ? plus.nativeUI.actionSheet({
		title: '分享资讯',
		cancel: '取消',
		buttons: shareBts
	}, function(e) {
		(e.index > 0) && shareAction(shareBts[e.index - 1], true);
	}) : plus.nativeUI.alert('当前环境无法支持分享链接操作!');
}
