mui.init();
var vm = new Vue({
	el: "#muiContent",
	data: {
		newsData: [],
		connect: [],
		categoryList: []
	},
	filters: {
		Substrs: function(num) {
			return(num.length < 4 ? num : num.substring(0, 4));
		}
	},
	methods: {
		jumpDetails: function(e) {
			if(e.currentTarget.getAttribute('category')) {
				var category = e.currentTarget.getAttribute('category');
			}
			if(e.currentTarget.getAttribute('variety')) {
				var variety = e.currentTarget.getAttribute('variety');
			}
			if(e.currentTarget.getAttribute('tradeMarket')) {
				var tradeMarket = e.currentTarget.getAttribute('tradeMarket');
				console.log(tradeMarket);
			}
			mui.openWindow({
				url: 'purse_dteials.html',
				id: 'purse_dteials',
				styles: {
					top: 0,
					bottom: 0
				},
				extras: {
					category: category,
					variety: variety,
					tradeMarket: tradeMarket
				}
			})
		},
		chooseCategory: function(e) {
			var categoryName = e.currentTarget.getAttribute('data');
			mui.openWindow({
				url: "price_info.html",
				id: "price_info",
				styles: {
					top: 0,
					bottom: 0
				},
				extras: {
					names: categoryName
				}
			});
		}
	}
})
mui.plusReady(function() {
	document.addEventListener('JFreload', function(event) {
		var status = event.detail.status;
		console.log(status);
		if(status == 1) {
			ajax(xnzbUrl + '/api-content/discovery/followVariety', {
				data: {
					pageNo: 1,
					pageSize: 100,
					token: token
				},
				dataType: 'json',
				type: 'get',
				timeout: 10000,
				success: function(data) {
					console.log(data);
					vm.connect = data.data.page.result;
					if(vm.connect.length > 3) {
						$("#slide-box").addClass("jk");
					} else {
						$("#slide-box").removeClass("jk");
					}
				},
				error: function(xhr, type, errorThrown) {
					mui.toast('网络繁忙，请稍后重试！');
				}
			});
			ajax(xnzbUrl + '/api-content/news/page', {
				data: {
					pageNo: 1,
					pageSize: 10,
					keyword: '',
					type: 5
				},
				dataType: 'json',
				type: 'get',
				timeout: 10000,
				success: function(data) {
					vm.newsData = data.data.newsList;
				},
				error: function(xhr, type, errorThrown) {
					mui.toast('网络繁忙，请稍后重试！');
				}
			});

		}
	});
	//预加载详情页
	webview_detail = mui.preload({
		url: 'policyDetail.html',
		id: 'policyDetail',
		styles: {
			"render": "always", //窗口渲染模式
			"popGesture": "hide",
			"bounce": "vertical" //窗口遇到边框是否有反弹效果 vertical表示垂直方向反弹
		}
	});
	var geo_province = plus.storage.getItem('geo_province');
	var geo_city = plus.storage.getItem('geo_city');
	var geo_district = plus.storage.getItem('geo_district');
	view = plus.webview.currentWebview();

	/*function changedata(e) {
		var status = e.detail.status;
		console.log(status);
		if(status == 1) {
			ajax(xnzbUrl + '/api-content/discovery/followVariety', {
				data: {
					pageNo: 1,
					pageSize: 100,
					token: token
				},
				dataType: 'json',
				type: 'get',
				timeout: 10000,
				success: function(data) {
					console.log(data);
					vm.connect = data.data.page.result;
				},
				error: function(xhr, type, errorThrown) {
					mui.toast('网络繁忙，请稍后重试！');
				}
			});
		}

	}
	window.addEventListener('servers', changedata);*/

	ajax(xnzbUrl + '/api-content/discovery/followVariety', {
		data: {
			pageNo: 1,
			pageSize: 100,
			token: token
		},
		dataType: 'json',
		type: 'get',
		timeout: 10000,
		success: function(data) {
			console.log(data);
			vm.connect = data.data.page.result;
			console.log(vm.connect.length)
			if(vm.connect.length > 3) {
				$("#slide-box").addClass("jk");
			} else {
				$("#slide-box").removeClass("jk");
			}
		},
		error: function(xhr, type, errorThrown) {
			mui.toast('网络繁忙，请稍后重试！');
		}
	});
	ajax(xnzbUrl + '/api-content/discovery/categoryList', {
		data: {
			pageNo: 1,
			pageSize: 100
		},
		dataType: 'json',
		type: 'get',
		timeout: 10000,
		success: function(data) {
			vm.categoryList = data.data.page.result;
			$(".updata").text(data.data.lastReportTime);
		},
		error: function(xhr, type, errorThrown) {
			mui.toast('网络繁忙，请稍后重试！');
		}
	});
	ajax(xnzbUrl + '/api-content/news/page', {
		data: {
			pageNo: 1,
			pageSize: 10,
			keyword: '',
			type: 5
		},
		dataType: 'json',
		type: 'get',
		timeout: 10000,
		success: function(data) {
			vm.newsData = data.data.newsList;
		},
		error: function(xhr, type, errorThrown) {
			mui.toast('网络繁忙，请稍后重试！');
		}
	});

})
//点击列表，打开详情
mui('.xnzb-zczx-cont').on('tap', 'li', function() {
	var detailId = this.getAttribute('id');
	var title = this.querySelector(".title").innerHTML;
	var author = this.querySelector(".content").innerHTML;
	var time = this.querySelector("#time").innerHTML;
	var read = this.querySelector("#read").innerHTML;
	var cover = this.querySelector(".zczx-num-img") ? this.querySelector(".cpimg").getAttribute("src") : '';
	var type = 5;
	open_detail(detailId, title, author, time, read, cover, type);
});
//打开资讯详情
function open_detail(detailId, title, author, time, read, cover, type) {
	//若详情页尚未预加载完成，则延时等待再执行
	if(!webview_detail) {
		setTimeout(function() {
			open_detail(detailId);
		}, 100);
	}
	//触发子窗口变更新闻详情  触发自定义事件
	mui.fire(webview_detail, 'get_detail', {
		detailId: detailId,
		title: title,
		author: author,
		time: time,
		read: read,
		cover: cover,
		type: type
	});
	setTimeout(function() {
		webview_detail.show("slide-in-right", 300);
	}, 150);
}

function choosesome() {
	mui.openWindow({
		url: "price_seach.html",
		id: "price_seach",
		styles: {
			top: 0,
			bottom: 0
		},
		extras: {
			routers: 1
		}
	});
}