/**
 * 下拉刷新类定义
 */
var pfx = ["webkit", "moz", "MS", "o", ""];
function PrefixedEvent(element, type, callback) {
	for (var p = 0; p < pfx.length; p++) {
		if (!pfx[p]) type = type.toLowerCase();
		element.addEventListener(pfx[p]+type, callback, false);
	}
}

var PullDownRefresh = function(options) {
	this.container = options['container'];
	this.callback = options['callback'];
	this.is_draging = false;
	window.is_pulldownloading = false;
	this.start_delta_y = 0;
	this.delta_y = 0;

	//解决底部会出现一块空白问题
	this.doneTransition = false;
	this.scrollPlaceHolder = document.querySelector(".for_placescroll");
};
PullDownRefresh.prototype = {
	//可以在这里提供Person的基本功能
	init: function() {
		// 创建下拉可以刷新div
		var div_node = document.createElement('div');
		div_node.setAttribute('class', 'mui-pull-top-pocket mui-block mui-visibility');
		var html = '<!--div class="mui-pull-top-pocket mui-block mui-visibility" style="-webkit-transform: translate3d(0px, -50px, 0px);"-->' +
			'     <div class="mui-pull">' +
			'        <div class="mui-pull-loading mui-icon mui-icon-pulldown" style="-webkit-transition: -webkit-transform 200ms ease; transition: -webkit-transform 200ms ease; -webkit-transform: rotate(0deg);"></div>' +
			'        <div class="mui-pull-caption">下拉可以刷新</div>' +
			'     </div>' +
			'<!--/div-->';
		div_node.innerHTML = html;

		var parent = document.querySelector(this.container);
		parent.insertBefore(div_node, parent.childNodes[0]);

		// 设置初始位置
		document.querySelector(this.container + " .mui-pull-top-pocket").style.webkitTransform = 'translate3d(0,-50px,0)';
		document.querySelector(this.container + " .mui-scroll").style.webkitTransform = 'translate3d(0,0,0)';

		//解决底部会出现一块空白问题
		var $that = this;
		PrefixedEvent(document.querySelector(this.container + " .mui-scroll"), 'TransitionEnd', function(){
			if($that.doneTransition){
				$that.scrollPlaceHolder.style.display = "none";
				setTimeout(function(){
					$that.scrollPlaceHolder.style.display = "block";
				},50);
				$that.doneTransition = false;
			}
		});



		var that = this;
		document.querySelector(this.container).addEventListener('drag', function(e) {
			// 第一次滑动
			if (window.is_pulldownloading) {
				return;
			}
			if (!that.is_draging) {
				if (e.detail.direction === 'down') {
					that.is_draging = true;
					that.start_delta_y = e.detail.deltaY;

					document.querySelector(that.container + " .mui-pull-top-pocket").style.webkitTransform = 'translate3d(0,-50px,0)';
					document.querySelector(that.container + " .mui-pull-loading").setAttribute('class', 'mui-pull-loading mui-icon mui-icon-pulldown');

					document.querySelector(that.container + " .mui-pull-top-pocket").classList.remove('transitioning');
					document.querySelector(that.container + " .mui-scroll").classList.remove('transitioning');
				} else if (e.detail.direction === 'up') {
					that.is_draging = true;
				}
			}
			if (that.is_draging) {
				if (e.detail.direction === 'down') {
					e.stopPropagation();

					that.delta_y = e.detail.deltaY - that.start_delta_y;
					// 判断滑动距离，如果大于下拉加载区域的高，就翻转箭头
					if (that.delta_y >= 100) {
						document.querySelector(that.container + " .mui-pull-caption").innerText = '释放立即刷新';
						document.querySelector(that.container + " .mui-pull-loading").style.webkitTransform = 'rotate(-180deg)';
					} else {
						document.querySelector(that.container + " .mui-pull-caption").innerText = '下拉可以刷新';
						document.querySelector(that.container + " .mui-pull-loading").style.webkitTransform = 'rotate(0deg)';
					}
				} else if (e.detail.direction === 'up') {
					e.stopPropagation();

					that.delta_y = e.detail.deltaY - that.start_delta_y;
					// 判断滑动距离，如果大于下拉加载区域的高，就翻转箭头
					if (that.delta_y >= 100) {
						//document.querySelector(that.container+" .mui-pull-caption").innerText = '释放立即刷新';
						document.querySelector(that.container + " .mui-pull-loading").style.webkitTransform = 'rotate(-180deg)';
					} else {
						document.querySelector(that.container + " .mui-pull-caption").innerText = '下拉可以刷新';
						document.querySelector(that.container + " .mui-pull-loading").style.webkitTransform = 'rotate(0deg)';
					}
				}
			}
		});

		document.querySelector(this.container).addEventListener('dragend', function(e) {
			if (that.is_draging) {
				that.is_draging = false;

				// 放开的时候，判断当前滚动条距离顶部滚动了多远, 如果没有往下拉，滚动条在下面，则return;
				var scroll_top = document.querySelector(that.container).scrollTop;
				if (scroll_top >= 0) {
					// 当在底部下拉滑动到顶部时，拖动距离可能超过100，始终保持文字为“下拉可以刷新”
					document.querySelector(that.container + " .mui-pull-caption").innerText = '下拉可以刷新';
					document.querySelector(that.container + " .mui-pull-loading").style.webkitTransform = 'rotate(0deg)';
					return;
				}

				if (that.delta_y >= 100) {
					window.is_pulldownloading = true;
					document.querySelector(that.container + " .mui-pull-caption").innerText = '努力加载中...';
					document.querySelector(that.container + " .mui-pull-loading").setAttribute('class', 'mui-pull-loading mui-icon mui-spinner');

					document.querySelector(that.container + " .mui-pull-top-pocket").style.webkitTransform = 'translate3d(0,0,0)';
					document.querySelector(that.container + " .mui-scroll").style.webkitTransform = 'translate3d(0,50px,0)';


					document.querySelector(that.container + " .mui-pull-top-pocket").classList.add('transitioning');
					//TODO 有点小不足的地方，.mui-scroll加上动画后，在刷新后，底部会出现一块空白,再刷新又正常，循环往复
					// 因为.mui-scroll延迟0.25s再滑上去，而框架没有缩回, 需要以后解决
					document.querySelector(that.container + " .mui-scroll").classList.add('transitioning');

					// callback
					setTimeout(function(){
						that.callback();
					},500);
				}
			}
		})

	},
	endPullDownToRefresh: function() {
		var that = this;

		//解决底部会出现一块空白问题
		if(window.is_pulldownloading){
			that.doneTransition = true;
		}

		window.is_pulldownloading = false;
		document.querySelector(this.container + " .mui-pull-top-pocket").style.webkitTransform = 'translate3d(0,-50px,0)';
		document.querySelector(this.container + " .mui-scroll").style.webkitTransform = 'translate3d(0,0,0)';
	}
}

/**
 * 上拉加载功能实现, 使用原生滚动
 * @param {Array} options
 * options: {
 *    container: '#content' // 容器 
 *    callback: load_more_function // 上拉加载业务逻辑
 * }
 * @author fanrong33
 * @version 1.0.1 build 20150705
 */
var PullupLoad = function(options) {
	this.container = options['container'];
	this.callback = options['callback'];
	this.disable = false;
	this.isloading = false;
};

PullupLoad.prototype = {
	init: function(){
		this.bottomPullDiv = document.createElement('div');
		this.bottomPullDiv.setAttribute('class', 'mui-pull-bottom-pocket');
		var html = '<!--div class="mui-pull-top-pocket mui-block mui-visibility" style="-webkit-transform: translate3d(0px, -50px, 0px);"-->' +
			'     <div class="mui-pull"><div class="mui-pull-loading mui-icon mui-spinner"></div>' +
    	'					<div class="mui-pull-caption mui-pull-caption-down">正在加载...</div>' +
  		'			</div>' +
			'<!--/div-->';
		this.bottomPullDiv.innerHTML = html;

		var parent = document.querySelector(this.container).querySelector('.mui-scroll');
		parent.appendChild(this.bottomPullDiv);
		var $that = this;
		document.querySelector(this.container).addEventListener('scroll', function() {
			// 没放开，直接打回
			if (is_touch) return;

			var scroll_height = this.scrollHeight; // 滚动条的高度
			var scroll_top = this.scrollTop; // 滚动了多少像素
			var offset_height = this.offsetHeight; // 偏移的高度
			// 放开了，并且滑动到最底部，则加载更多
			if (!is_touch && scroll_top >= scroll_height - offset_height - 10) {
				// console.log('加载更多');
				if(!$that.disable && !window.is_pulldownloading){
					if(!$that.isloading){
						$that.bottomPullDiv.classList.add("mui-visibility");
						$that.isloading = true;
						$that.callback();
					}
				}
			} else {
				// 放开了，并且在上面游荡
				return;
			}
		})

		var is_touch = false;
		document.querySelector(this.container).addEventListener('touchstart', function() {
			is_touch = true;
		}, false);
		document.querySelector(this.container).addEventListener('touchend', function() {
			is_touch = false;
		}, false);
	},
	endPullupToRefresh: function(){
		this.isloading = false;
		this.bottomPullDiv.classList.remove("mui-visibility");
	},
	disablePullupToRefresh: function(){
		this.disable = true;
		this.bottomPullDiv.classList.remove("mui-visibility");
	},
	enablePullupToRefresh: function(){
		this.disable = false;
		this.isloading = false;
	}
};

var pullup_load = function(options) {
	var obj = new PullupLoad(options);
	obj.init();
	return obj;
};

var pulldown = null;
var pulldown_refresh = function(options) {
	var obj = new PullDownRefresh(options);
	obj.init();
	return obj;
}