/**
 * Created by tianchao on 2019/3/22
 */
var loandemand = (function () {
    var rate;
    var contact;
    var userId ;
    /* 新增字段 add by tianchao 2017-7-20*/
    var userCode;//用户标识
    var farmname;//主体名称
    var idcardno;//法人身份证号
    var address;//主体地址
    /*end 新增字段*/
    var termUnit;
    var contactPhone;
    var self;
    var orgcode;
    var maxLoan=0;//最大可贷

    var token="";
    var user=null;//主体信息

    var picker_use = new mui.PopPicker();//用途选择组件
    var picker_pledge = new mui.PopPicker();//抵押物选择组件
    var monthpicker = new mui.PopPicker({layer: 2});//贷款期限选择组件
    var pickdatayesno = [{"value":"1","text":"是"},{"value":"0","text":"否"}];

    //初始化app
    function init() {
        // 获取当前窗口对象
        self = plus.webview.currentWebview();
        token = plus.storage.getItem("token");
        loaduser();
        getuse();
        getpledge();
        getmaxloanamount();
        bindEvent();
    }

    //绑定页面事件
    function bindEvent() {
        // 勾选同意条款
        document.getElementById("js-agreecheck").addEventListener("tap",function () {
            if ($(this).hasClass("agree_tip-checked")) {
                $(this).removeClass('agree_tip-checked');
                $("#btnbuy").addClass('o_btnbox-gray');
            } else {
                $(this).addClass('agree_tip-checked');
                $("#btnbuy").removeClass('o_btnbox-gray');
            }
        });
        //选择贷款期限
        document.getElementById("selmonth").addEventListener('tap', function () {
            document.activeElement.blur();
            var pickdata = [];

            var months=[];
            for (var i = 0; i <= 12; i++) {
                months.push({"value": i, "text": i + "月"});
            }
            for (var i = 1; i <= 10; i++) {
                pickdata.push({value: i + "", text: i + "年", children: months});
            }
            monthpicker.setData(pickdata);
            monthpicker.show(function (selectItems) {
                // console.log(selectItems[0].text);
                // console.log(selectItems[0].value);
                var year=selectItems[0].value;
                var month=selectItems[1].value;
                if(month==0){
                    document.getElementById("selmonth").value = year+"年";
                }
                else {
                    document.getElementById("selmonth").value = year+"年"+month+"月";
                }
                document.getElementById("selmonth").dataset.year = year;
                document.getElementById("selmonth").dataset.month = month;
            })

        }, false);

        //选择用途
        document.getElementById("seluse").addEventListener('tap', function () {
            document.activeElement.blur();
            picker_use.show(function (selectItems) {
                // console.log(selectItems[0].text);
                // console.log(selectItems[0].value);
                document.getElementById("seluse").value = selectItems[0].text;
                document.getElementById("seluse").dataset.valueid = selectItems[0].value;
            })
        }, false);

        //是否有抵押物
        document.getElementById("haspledge").addEventListener('tap', function () {
            document.activeElement.blur();
            picker_pledge.show(function (selectItems) {
                document.getElementById("haspledge").value = selectItems[0].text;
                document.getElementById("haspledge").dataset.valueid = selectItems[0].value;
                if(selectItems[0].value==0){
                    //选择的是其他，则要求输入
                    document.getElementById("pledgeotherbox").style.display="block";
                }
                else {
                    document.getElementById("pledgeotherbox").style.display="none";
                }
            });
        }, false);

        //是否有担保人
        document.getElementById("hassurety").addEventListener('tap', function () {
            document.activeElement.blur();
            var pickersurety = new mui.PopPicker();
            pickersurety.setData(pickdatayesno);
            pickersurety.show(function (selectItems) {
                document.getElementById("hassurety").value = selectItems[0].text;
                document.getElementById("hassurety").dataset.valueid = selectItems[0].value;
            })
        }, false);

        //提交
        document.getElementById("btnbuy").addEventListener('tap', function () {
            if (!$("#js-agreecheck").hasClass("agree_tip-checked")) {
                return;
            }

            document.activeElement.blur();
            var money = document.getElementById("money").value;
            var selyear = document.getElementById("selmonth").dataset.year;
            var selmonth = document.getElementById("selmonth").dataset.month;
            var maxrate=document.getElementById("maxrate").value;
            var seluse = document.getElementById("seluse").dataset.valueid;
            var months=0;//贷款的月份

            if (money <= 0) {
                mui.toast("请输入贷款金额");
                return;
            }
            var reg=/^\d+$/;//只能输入整数
            if(!reg.test(money)){
                mui.toast("贷款金额只能输入整数，");
                return;
            }
            if(maxLoan>0 && parseFloat(money) > parseFloat(maxLoan)){
                mui.toast("当前贷款最高可贷"+maxLoan+"万元，请重新输入贷款金额");
                return;
            }
            if (selyear==0&&selmonth == 0) {
                mui.toast("请选择贷款期限");
                return;
            }
            months=selyear*12+selmonth*1;
            if(maxrate<=0){
                mui.toast("请输入最大接受贷款利率");
                return;
            }
            if(isNaN(maxrate)){
                mui.toast("请输入正确的最大接受贷款利率");
                return;
            }
            if (seluse == 0) {
                mui.toast("请选择贷款用途");
                return;
            }
            var pledgeid=document.getElementById("haspledge").dataset.valueid;//抵押物id
            if(pledgeid==-1){
                //没有选择
                mui.toast("请选择抵押物");
                return;
            }
            var pledgename="";//抵押物名称
            if(pledgeid==0){
                //选择了其他
                pledgename=document.getElementById("pledgeother").value;
                pledgename=$.trim(pledgename);
                if(pledgename==""){
                    mui.toast("请输入其他抵押物");
                    return;
                }
            }
            else{
                pledgename=document.getElementById("haspledge").value;
            }

            var btnArray = ['取消', '确定'];
            mui.confirm('确定发布贷款需求？', '提示', btnArray, function (e) {
                if (e.index == 1) {
                    submiappointment(money,months,maxrate,seluse,pledgeid,pledgename);
                } else {

                }
            });
        }, false);
    }

    //获取用户信息
    function loaduser() {
        var url = applib.REQUEST_DOMAIN_SY+"api-account/getUserByToken?token="+token;
        mui.ajax(url, {
            data: {},
            dataType: 'json',
            type: 'get',
            timeout: 10000,
            //headers: {"Authorization": "Bearer " + token},
            success: function(d) {
                //最新返回值：{"code":0,"msg":"","data":{"farmName":null,"city":null,"photo":null,"isHzs":null,"isAuthed":"0","userId":256552,"score":0,"province":"其它",
                // "contact":"15051581257","district":null,"farmer":null,"addr":null,"idNum":null,"uniqueId":null},"timestamp":1500441862286}
                if(d.code!=0){
                    //获取失败
                    mui.toast("获取用户信息失败，请稍后重试");
                    return;
                }
                user=d.data;//用户对象
                document.getElementById("username").innerText = user.farmer;
            },
            error: function(xhr, type, errorThrown) {
                mui.toast("网络繁忙，请稍后重试！");
            }
        })
    }

    //获取抵押物列表
    function getpledge() {
        var url = applib.REQUEST_DOMAIN + "commonTypes/getCommonTypesByType?type=1";
        applib.ajax(url, {
            dataType: 'json',
            type: 'get',
            timeout: 10000,
            success: function (data) {
                //var data={code:0,msg:'',data:[{"id":7,"code":null,"name":"房产","icon":"","type":null,"status":1,"sort":0,"createtime":1553244565000}]};
                //[{"id":7,"code":null,"name":"房产","icon":"","type":null,"status":1,"sort":0,"createtime":1553244565000}]
                if(data.code!=0) {
                    mui.toast(data.msg);
                    return;
                }
                var resdata=data.data.commonType;
                if(resdata){
                    resdata.push({"id":0,"name":"其他"});
                }
                var pickdata = [];
                //数据转化成组件需要的数据
                for (var i = 0; i < resdata.length; i++) {
                    //[{"value":"1","text":"是"},{"value":"0","text":"否"}];
                    pickdata.push({
                        "value":resdata[i].id,
                        "text":resdata[i].name
                    });
                }
                picker_pledge.setData(pickdata);
            },
            error: function (xhr, type, errorThrown) {
                console.log(JSON.stringify(xhr));
                mui.toast("网络繁忙，请稍后重试！");
            }
        });
    }

    //获取贷款用途
    function getuse() {
        var url = applib.REQUEST_DOMAIN + "loan/purpose";
        applib.ajax(url, {
            dataType: 'json',
            type: 'get',
            timeout: 10000,
            success: function (data) {
                //[{"id":1,"value":2,"text":"fdfdf","recordStatus":true}]
                var pickdata = data;
                picker_use.setData(pickdata);
            },
            error: function (xhr, type, errorThrown) {
                console.log(JSON.stringify(xhr));
                mui.toast("网络繁忙，请稍后重试！");
            }
        });
    }

    //获取配置的最大可贷金额（万元）
    function getmaxloanamount() {
        var url = applib.REQUEST_DOMAIN + "loan/application/maxamount";
        applib.ajax(url, {
            dataType: 'json',
            type: 'get',
            timeout: 10000,
            success: function (data) {
                //最大可贷：后台配置的最高可贷款
                maxLoan=parseFloat(data.valuetext);
            },
            error: function (xhr, type, errorThrown) {
                console.log(JSON.stringify(xhr));
                mui.toast("网络繁忙，请稍后重试！");
            }
        });
    }

    function submiappointment(money,months,maxrate,seluse,pledgeid,pledgename) {
        var url = applib.REQUEST_DOMAIN + "loanDemand/add?token="+token;

        var hassurety = document.getElementById("hassurety").dataset.valueid;
        var data = {
            "amount":money,
            "maxRate":maxrate,
            "term":months,
            "purposeId": seluse,
            "pledgeId":pledgeid,
            "pledgeName":pledgename,
            "hassurety":hassurety
        }
        console.log(JSON.stringify(data));
        mui.ajax(url, {
            data: JSON.stringify(data),
            dataType: 'json',
            type: 'POST',
            headers: {'Content-Type': 'application/json'},
            timeout: 30000,
            success: function (data) {
                if(data.code!=0){
                    mui.toast(data.msg);
                    return;
                }
                mui.toast("申请成功，请等待银行响应");
                applib.openWindow("myloan.html", "myloan", {});
                setTimeout(function () {
                    self.close("none");
                }, 500);
            },
            error: function (xhr, type, errorThrown) {
                applib.hideLoadingBg();
                console.log(JSON.stringify(xhr));
                mui.toast("网络繁忙，请稍后重试！");
            }
        });
    }

    return {
        init: init
    }

})();

//appIndex.init();
mui.plusReady(function () {
    mui.init();
    loandemand.init();
});
