mui.plusReady(function() {

  var token = plus.storage.getItem('token')
  // var xnzbUrl = 'http://192.168.199.237:8980'

  var app = new Vue({
    el: '#app',
    data: function() {
      return {
        pmdWidth: 0,
        pmdList: [],
        integralActivity: [],
        shopUrl: '',
        ads: [],
        action: {},
        modalVisible: false,
        modalContent: '',
        ruleDialog: false,
        rule: ''  // 积分规则
      }
    },
    created: function() {
      this.getShopUrl()
      this.getPmdList()
      this.getAds()
      this.getRules()
    },
    mounted: function() {
      var headerHeight = document.getElementById('header').offsetHeight
      document.getElementById('pmdWrapper').style.top = (headerHeight - 1) + 'px'
    },
    methods: {
      getRules: function() {
        var self = this
        var url = xnzbUrl + '/api-admin/commonRules/queryByKeycode?keycode=share_integral_rule'
        mui.ajax(url, {
          data: {},
          type: 'get',
          timeout: 20000,
          success: function(data) {
            var res = JSON.parse(data)
            self.rule = res.valuetext
          },
          error: function(xhr, type, errorThrown) {
          }
        })
      },
      getShopUrl: function () {
        var self = this
        var url = prUrl + '/integral/getAutologinUrl'
        var data = {
          token:token
        }
        mui.ajax(url, {
          data: data,
          dataType: 'json',
          type: 'get',
          timeout: 10000,
          headers: {"token": token},
          success: function (response) {
            self.shopUrl = response.message
          }
        })
      },
      getPmdList: function() {
        var self = this
        var url = xnzbUrl + '/account-service/integralTaskActivity/query?token=' + token
        mui.ajax(url, {
          data: {},
          type: 'get',
          timeout: 20000,
          success: function(data) {
            if (data.code === 0) {
              var temp = data.data.integralBroadcast || []
              var pmdList = self.initImgArray(temp, 'img')
              pmdList = pmdList.concat(pmdList)

              self.pmdList = pmdList
              if (pmdList.length > 0) {
                self.startPmd()
                self.$nextTick(function() {
                  var pmdHeight = document.getElementById('pmdWrapper').offsetHeight
                  var headerHeight = document.getElementById('header').offsetHeight
                  document.getElementById('muiContent').style.paddingTop = (pmdHeight + headerHeight) + 'px'
                })
              }

              var integralActivity = self.initImgArray(data.data.integralActivity || [], 'imgUrl')
              self.integralActivity = integralActivity
            }
          },
          error: function(xhr, type, errorThrown) {
          }
        })
      },
      getAds: function() {
        var self = this
        var url = xnzbUrl + '/account-service/pageAds/queryAds?token=' + token + '&pageCode=renwuhuodong&position=rw01'
        mui.ajax(url, {
          data: {},
          type: 'get',
          timeout: 20000,
          success: function(data) {
            if (data.code === 0) {
              self.ads = data.data || []
            }
          },
          error: function(xhr, type, errorThrown) {
          }
        })
      },
      initImgArray: function(data, key) {
        var array = []
        data.forEach(function(item) {
          if (item[key].indexOf('http') > -1) {
            array.push(item)
          } else {
            item[key] = xnzbImg + item[key]
            array.push(item)
          }
        })
        return array
      },
      startPmd: function() {
        this.$nextTick(function() {
          this.pmdWidth = parseInt(this.$refs.pmdContent.offsetWidth / 2)
          this.stepAmination()
        })
      },
      stepAmination: function() {
        var left = this.$refs.pmdContent.offsetLeft
        if (this.pmdWidth === Math.abs(left)) {
          this.$refs.pmdContent.style.left = 0
        } else {
          this.$refs.pmdContent.style.left = left - 1 + 'px'
        }
        window.requestAnimationFrame(this.stepAmination)
      },
      showRuleModal: function() {
        overflowStatus = document.body.style.overflow

        document.body.style.overflow = 'hidden'
        this.ruleDialog = true
      },
      closeRuleModal: function() {
        this.ruleDialog = false
        document.body.style.overflow = overflowStatus
      },
      linkToShop: function() {
        var self = this
        var params = {
          title: '任务活动',
          token: token,
          actionName: '积分商城',
        }
        buryPoint(params, function() {
          if(self.shopUrl){
            window.showLoadedPage({
              url: '../support/pages/common/webbrowse.html',
              id: 'webbrowse',
              extras: {
                url: self.shopUrl,
              },
              delay: 500
            });
          }
        })
      },
      handleClick: function(item, type) {
        var params = {
          title: '任务活动页面',
          token: token,
          data: item.id
        }
        if (type === 'pmd') {
          params.actionName = '跑马灯'
        }
        if (type === 'active') {
          params.actionName = '活动'
        }
        if (type === 'ads') {
          params.actionName = '广告区'
        }
        buryPoint(params)
        if (item. isShowFrame === 1) {
          this.modalVisible = true
          this.modalContent = item.frameContent
        }
        this.action = {
          type: item.actionCode,
          value: item.actionValue
        }
      },
      actionCreator: function(item, type) {
        this.modalVisible = false
        store.dispatch(this.action)
      }
    }
  })
})