mui.init();
var aniShow = "pop-in";
var myDate = new Date();//获取系统当前时间
var currentYear = myDate.getFullYear(); //获取完整的年份
var currentMonth = myDate.getMonth() + 1; //获取当前月份
var currentDay = myDate.getDate(); //获取当前日(1-31)
if(currentMonth < 10){
	currentMonth = '0' + currentMonth;
}
if(currentDay < 10){
	currentDay = '0' + currentDay;
}
var yearOfmonth = currentYear + '-' + currentMonth + '-' + '01';
var token;
var colors = ['#2BBE77','#FFC200','#3A68FF','#FF6F3A','#3AA9FF','#763AFF','#FFD800','#00D0BB'];
muiid('muiTitle').innerText = currentYear + '年统计';
muiid('weekInTitle').innerText = '本周收支汇总';
muiid('monthInTitle').innerText = currentYear + '年本月收入汇总图';
muiid('monthOutTitle').innerText = currentYear + '本月支出汇总图';
muiid('yearInOutTitle').innerText = currentYear + '年各月收支曲线图';
muiid('yearInOutPieTitle').innerText = currentYear + '年收支汇总图';
muiid('yearInTitle').innerText = currentYear + '年收入汇总图';
muiid('yearOutTitle').innerText = currentYear + '年支出汇总图';

mui.plusReady(function() {
	token = plus.storage.getItem('token');
	//本周收支汇总
	ajax(xnzbUrl + '/api-report/form/queryForWeekAmount.json', {
		data: {
			token:token
		},
		dataType: 'json',
		type: 'POST',
		timeout: 10000,
		success: function(data) {
			if(!data.code){
				var list=data.data;
				if(list.expense.length>0 || list.income.length>0){
					weekOutPiess(data.data.expense,data.data.income);
				}else{
					muiid('weekInPie').innerHTML = '<div class="heng"><img src="../../static/img/mystatus-nodata.png" />暂无数据，快去记账吧</div>';
				}
			}
		},
		error: function(xhr, type, errorThrown) {
			mui.toast("网络繁忙，请稍后重试！");
		}
	});
	//本月收入
	ajax(xnzbUrl + '/api-report/form/monthInOrExpStatistic.json', {
		data: {
			token:token,
			category: 4,
			yearOfmonth: yearOfmonth
		},
		dataType: 'json',
		type: 'POST',
		timeout: 10000,
		success: function(data) {
			if(!data.code){
				var list = data.data.list;
				if(list.length > 0){
					var legend = [];
					var data = [];
					for(var i=0;i<list.length;i++){
						var leg = list[i].name;
						var val = list[i].amount;
						var dat = {
							name: leg,
		                	value: val,
		                	itemStyle: {
		                		normal: {
		                			color: colors[i]
		                		}
		                	}
						}
						legend.push(leg);
						data.push(dat);
					}
					monthInPiess(legend,data);
				}else{
					muiid('monthInPie').innerHTML = '<div class="mystatusNodata"><img src="../../static/img/mystatus-nodata.png" />暂无数据，快去记账吧</div>';
				}
			}
		},
		error: function(xhr, type, errorThrown) {
			mui.toast("网络繁忙，请稍后重试！");
		}
	});
	//本月支出
	ajax(xnzbUrl + '/api-report/form/monthInOrExpStatistic.json', {
		data: {
			token:token,
			category: 3,
			yearOfmonth: yearOfmonth
		},
		dataType: 'json',
		type: 'POST',
		timeout: 10000,
		success: function(data) {
			if(!data.code){
				var list = data.data.list;
				if(list.length > 0){
					var legend = [];
					var data = [];
					for(var i=0;i<list.length;i++){
						var leg = list[i].name;
						var val = list[i].amount;
						var dat = {
							name: leg,
		                	value: val,
		                	itemStyle: {
		                		normal: {
		                			color: colors[i]
		                		}
		                	}
						}
						legend.push(leg);
						data.push(dat);
					}
					monthOutPiess(legend,data);
				}else{
					muiid('monthOutPie').innerHTML = '<div class="mystatusNodata"><img src="../../static/img/mystatus-nodata.png" />暂无数据，快去记账吧</div>';
				}
			}
		},
		error: function(xhr, type, errorThrown) {
			mui.toast("网络繁忙，请稍后重试！");
		}
	});
	//各月收支曲线图
	ajax(xnzbUrl + '/api-report/form/yearOfmonthInOrExpStatistic.json', {
		data: {
			token:token,
			category:'3,4',
			year:currentYear
		},
		dataType: 'json',
		type: 'POST',
		timeout: 10000,
		success: function(data) {
			if(!data.code){
				var inData = data.data[3];
				var inDataList = [0,0,0,0,0,0,0,0,0,0,0,0];
				var outData = data.data[4];
				var outDataList = [0,0,0,0,0,0,0,0,0,0,0,0];
				if(inData.length > 0 || outData.length > 0){
					if(inData.length > 0){
						for(var i=0;i<inData.length;i++){
							inDataList[inData[i].month - 1] = inData[i].amount / 10000;
						}
					}
					if(outData.length > 0){
						for(var i=0;i<outData.length;i++){
							outDataList[outData[i].month - 1] = outData[i].amount / 10000;
						}
					}
					yearInOutLiness(inDataList,outDataList);
				}else{
					muiid('yearInOutLine').innerHTML = '<div class="mystatusNodata"><img src="../../static/img/mystatus-nodata.png" />暂无数据，快去记账吧</div>';
				}
			}	
		},
		error: function(xhr, type, errorThrown) {
			mui.toast("网络繁忙，请稍后重试！");
		}
	});
	//年收支汇总图
	ajax(xnzbUrl + '/api-report/form/financeCount.json', {
		data: {
			token:token,
			year:currentYear
		},
		dataType: 'json',
		type: 'POST',
		timeout: 10000,
		success: function(data) {
			if(!data.code){
				var income = data.data.income;
				var expense = data.data.expense;
				/*var amountReceive = data.data.amountReceive;
				var amountPay = data.data.amountPay;*/
				if(income > 0 || expense > 0){
					var legend = ["全年收入","全年支出"];
					var data = [
						{
							name: "全年收入",
		                	value: income,
		                	itemStyle: {
		                		normal: {
		                			color: '#4AABFA'
		                		}
		                	}
						},
						{
							name: "全年支出",
		                	value: expense,
		                	itemStyle: {
		                		normal: {
		                			color: '#F9D14D'
		                		}
		                	}
						}
					];
					yearInOut(legend,data);
				}else{
					muiid('yearInOutBar').innerHTML = '<div class="mystatusNodata"><img src="../../static/img/mystatus-nodata.png" />暂无数据，快去记账吧</div>';
				}
			}
		},
		error: function(xhr, type, errorThrown) {
			mui.toast("网络繁忙，请稍后重试！");
		}
	});
	//年收入汇总图
	ajax(xnzbUrl + '/api-report/form/yearInOrExpStatistic.json', {
		data: {
			token:token,
			category: 4,
			year:currentYear
		},
		dataType: 'json',
		type: 'POST',
		timeout: 10000,
		success: function(data) {
			if(!data.code){
				var list = data.data.list;
				if(list.length > 0){
					var legend = [];
					var data = [];
					for(var i=0;i<list.length;i++){
						var leg = list[i].name;
						var val = list[i].amount;
						var dat = {
							name: leg,
		                	value: val,
		                	itemStyle: {
		                		normal: {
		                			color: colors[i]
		                		}
		                	}
						}
						legend.push(leg);
						data.push(dat);
					}
					yearInPiess(legend,data);
				}else{
					muiid('yearInPie').innerHTML = '<div class="mystatusNodata"><img src="../../static/img/mystatus-nodata.png" />暂无数据，快去记账吧</div>';
				}
			}
		},
		error: function(xhr, type, errorThrown) {
			mui.toast("网络繁忙，请稍后重试！");
		}
	});
	//年支出汇总图
	ajax(xnzbUrl + '/api-report/form/yearInOrExpStatistic.json', {
		data: {
			token:token,
			category: 3,
			year:currentYear
		},
		dataType: 'json',
		type: 'POST',
		timeout: 10000,
		success: function(data) {
			if(!data.code){
				var list = data.data.list;
				if(list.length > 0){
					var legend = [];
					var data = [];
					for(var i=0;i<list.length;i++){
						var leg = list[i].name;
						var val = list[i].amount;
						var dat = {
							name: leg,
		                	value: val,
		                	itemStyle: {
		                		normal: {
		                			color: colors[i]
		                		}
		                	}
						}
						legend.push(leg);
						data.push(dat);
					}
					yearOutpiess(legend,data);
				}else{
					muiid('yearOutPie').innerHTML = '<div class="mystatusNodata"><img src="../../static/img/mystatus-nodata.png" />暂无数据，快去记账吧</div>';
				}
			}
		},
		error: function(xhr, type, errorThrown) {
			mui.toast("网络繁忙，请稍后重试！");
		}
	});
});

var byId = function(id) {
	return document.getElementById(id);
};
var weekInPie = echarts.init(byId('weekInPie'));
var monthInPie = echarts.init(byId('monthInPie'));
var monthOutPie = echarts.init(byId('monthOutPie'));
var yearInOutLine = echarts.init(byId('yearInOutLine'));
var yearInOutBar = echarts.init(byId('yearInOutBar'));
var yearInPie = echarts.init(byId('yearInPie'));
var yearOutPie = echarts.init(byId('yearOutPie'));
//本周收支汇总交叉图
function weekOutPiess(expense,income){
	var zhiExpense=[];
	var shouIncome=[];
	for(var i=0;i<expense.length;i++){
		if(expense[i].day=="星期一"){
			zhiExpense[0]="-"+expense[i].account;
		}
		if(expense[i].day=="星期二"){
			zhiExpense[1]="-"+expense[i].account;
		}
		if(expense[i].day=="星期三"){
			zhiExpense[2]="-"+expense[i].account;
		}
		if(expense[i].day=="星期四"){
			zhiExpense[3]="-"+expense[i].account;
		}
		if(expense[i].day=="星期五"){
			zhiExpense[4]="-"+expense[i].account;
		}
		if(expense[i].day=="星期六"){
			zhiExpense[5]="-"+expense[i].account;
		}
		if(expense[i].day=="星期日"){
			zhiExpense[6]="-"+expense[i].account;
		}
	}
	for(var j=0;j<income.length;j++){
		if(income[j].day=="星期一"){
			shouIncome[0]=income[j].account;
		}
		if(income[j].day=="星期二"){
			shouIncome[1]=income[j].account;
		}
		if(income[j].day=="星期三"){
			shouIncome[2]=income[j].account;
		}
		if(income[j].day=="星期四"){
			shouIncome[3]=income[j].account;
		}
		if(income[j].day=="星期五"){
			shouIncome[4]=income[j].account;
		}
		if(income[j].day=="星期六"){
			shouIncome[5]=income[j].account;
		}
		if(income[j].day=="星期日"){
			shouIncome[6]=income[j].account;
		}
	}
	var weekOutOption = {
	    tooltip : {
	        trigger: 'axis',
	        axisPointer : {            // 坐标轴指示器，坐标轴触发有效
	            type : 'shadow'        // 默认为直线，可选为：'line' | 'shadow'
	        }
	    },
	    legend: {
	        data:[
		        {
		        	name:'支出（元）',
		        	textStyle: {color: '#F2A83B'}
		        },
		        {
		        	name:'收入（元）',
		        	textStyle: {color: '#45A6F7'}
		        }
	        ],
	        
	    },
	    grid: {
	        left: '4%',
	        right: '4%',
	        bottom:"8%",
	        width:'90%',
	        height:'80%',
	        containLabel: true
	    },
	    xAxis : [
	        {
	            type : 'value'
	        }
	    ],
	    yAxis : [
	        {
	            type : 'category',
	            axisTick : {show: false},
	            data : ['星期一','星期二','星期三','星期四','星期五','星期六','星期日']
	        }
	    ],
	    series : [
	        {
	            name:'收入（元）',
	            type:'bar',
	            stack: '总量',
	            label: {
	                normal: {
	                    show: true,
	                    color:"#000000"
	                }
	            },
	            itemStyle:{
	            	normal: {
	            		color:"#45A6F7"
	            	}
	            },
	            data:shouIncome
	        },
	        {
	            name:'支出（元）',
	            type:'bar',
	            stack: '总量',
	            label: {
	                normal: {
	                    show: true,
	                    color:"#000000"
	                }
	            },
	            itemStyle:{
	            	 normal: {
	            		color:"#F2A83B"
	            	}
	            },
	            data:zhiExpense
	        }
	    ]
	};
	weekInPie.setOption(weekOutOption);
}
//本月收入汇总环形图
function monthInPiess(legend,data){
	var monthInOption = {
	    tooltip: {
	        formatter: "{b}: {c} ({d}%)"
	    },
	    legend: {
	        orient: 'vertical',
	        top: '13%',
	        left: '45%',
	        data: legend,
	        itemWidth: 8,
			itemHeight: 8
	    },
	    series: [
	        {
	            name:'本月收入汇总环形图',
	            type:'pie',
	            center: ['23%', '50%'],
	            radius: ['45%', '76%'],
	            avoidLabelOverlap: false,
	            label: {
	                normal: {
	                    show: false
	                }
	            },
	            labelLine: {
	                normal: {
	                    show: false
	                }
	            },
	            data:data
	        }
	    ]
	};
	monthInPie.setOption(monthInOption);
}
//本月支出汇总环形图
function monthOutPiess(legend,data){
	var monthOutOption = {
	    tooltip: {
	        formatter: "{b}: {c} ({d}%)"
	    },
	    legend: {
	        orient: 'vertical',
	        top: '13%',
	        left: '45%',
	        data: legend,
	        itemWidth: 8,
			itemHeight: 8
	    },
	    series: [
	        {
	            name:'本月支出汇总环形图',
	            type:'pie',
	            center: ['23%', '50%'],
	            radius: ['45%', '76%'],
	            avoidLabelOverlap: false,
	            label: {
	                normal: {
	                    show: false
	                }
	            },
	            labelLine: {
	                normal: {
	                    show: false
	                }
	            },
	            data: data
	        }
	    ]
	};
	monthOutPie.setOption(monthOutOption);
}

//年度收支汇总曲线图
function yearInOutLiness(inDataList,outDataList){
	var yearInOutLineOption = {
		grid: {
			left: '4%',
	    	right: '5%',
	    	top: '35',
	    	bottom: '10',
	    	containLabel: true
		},
		legend: {
	        orient: 'horizontal',
	        top: '0',
	        left: '30%',
	        data:['各月收入', '各月支出'],
	        itemWidth: 8,
			itemHeight: 8
	    },
		calculable: false,
		xAxis: [{
			type: 'category',
			boundaryGap: false,
			axisLine: {
				show: false
			},
			axisTick: {
				show: false
			},
			axisLabel:{
				interval: 0
			},
			data: ['1月','2月','3月','4月','5月','6月','7月','8月','9月','10月','11月','12月']
		}],
		yAxis: [{
			type: 'value',
			name: '(万元)',
			nameGap: 10,
			boundaryGap: false,
			axisLine: {
				show: false
			},
			axisTick: {
				show: false
			},
			splitLine: {
				show: false
			}
		}],
		series: [{
				name: '各月收入',
				type: 'line',
				smooth: true,
				showSymbol: false,
				connectNulls: true,
				symbol: 'rect',
				lineStyle: {
					normal: {
						width: 0
					}
				},
				zlevel:2,
				z: 2,
				itemStyle: {
					normal: {
						areaStyle: {
							color:'#2BBE77'
						},
						color:'#2BBE77'
					}
				},
				data: inDataList
			},
			{
				name: '各月支出',
				type: 'line',
				smooth: true,
				showSymbol: false,
				connectNulls: true,
				symbol: 'rect',
				lineStyle: {
					normal: {
						width: 0
					}
				},
				z: 1,
				itemStyle: {
					normal: {
						areaStyle: {
							color:'#3A68FF'
						},
						color:'#3A68FF'
					}
				},
				data: outDataList
			}
		
		]
	}
	yearInOutLine.setOption(yearInOutLineOption);
}

//年度收支汇总图
function yearInOut(legend,data){
	var yearInOutOption = {
	    tooltip: {
	        formatter: "{b}: {c}元 ({d}%)"
	    },
	    legend: {
	        orient: 'vertical',
	        top: '13%',
	        left: '45%',
	        data:legend,
	        itemWidth: 8,
			itemHeight: 8
	    },
	    series: [
	        {
	            name:'本年收支汇总环形图',
	            type:'pie',
	            center: ['23%', '50%'],
	            radius: ['0%', '76%'],
	            avoidLabelOverlap: false,
	            label: {
	                normal: {
	                    show: false
	                }
	            },
	            labelLine: {
	                normal: {
	                    show: false
	                }
	            },
	            data:data
	        }
	    ]
	};
	yearInOutBar.setOption(yearInOutOption);
}
/*function yearInOut(income,expense,amountReceive,amountPay){
	var yearInOutOption = {
		grid: {
			left: '-10%',
	    	right: '0%',
	    	top: '30',
	    	bottom: '20',
	    	containLabel: true
		},
		toolbox: {
			show: false,
			feature: {
				mark: {
					show: true
				},
				dataView: {
					show: true,
					readOnly: false
				},
				magicType: {
					show: true,
					type: []
				},
				restore: {
					show: true
				},
				saveAsImage: {
					show: true
				}
			}
		},
		calculable: false,
		legend: {
			data: ["全年收入","全年支出"],
			bottom : '10',
			itemWidth: 10,
			itemHeight: 10,
			itemGap: 50
		},
		xAxis: [{
			type: 'category',
			data: ["全年收入"],
			axisTick:{
				alignWithlabel:true
			},
			show:false
		}],
		yAxis: [{
			show: false
		}],
		series: [{
			name: '全年收入',
			type: 'bar',
			data: [income],
			label: {
	            normal: {
	                show: true,
	                position: 'top'
	            }
	        },
	        barWidth: 45,
	        barGap: 1.5,
			itemStyle: {
	            normal: {
	                barBorderRadius: 0,
	                color: new echarts.graphic.LinearGradient(0, 0, 0, 1, [{
	                    offset: 0,
	                    color: '#45A6F7'
	                }, {
	                    offset: 1,
	                    color: '#84CDF5'
	                }])
	            }
	        }
		},
		{
			name: '全年支出',
			type: 'bar',
			data: [expense],
			label: {
	            normal: {
	                show: true,
	                position: 'top'
	            }
	        },
	        barWidth: 45,
	        barGap: 1.5,
			itemStyle: {
	            normal: {
	                barBorderRadius: 0,
	                color: new echarts.graphic.LinearGradient(0, 0, 0, 1, [{
	                    offset: 0,
	                    color: '#F88D71'
	                }, {
	                    offset: 1,
	                    color: '#F25793'
	                }])
	            }
	        }
		}
		]
	}
	yearInOutBar.setOption(yearInOutOption);
}*/

//本年收入汇总环形图
function yearInPiess(legend,data){
	var yearInOption = {
	    tooltip: {
	        formatter: "{b}: {c} ({d}%)"
	    },
	    legend: {
	        orient: 'vertical',
	        top: '13%',
	        left: '45%',
	        data:legend,
	        itemWidth: 8,
			itemHeight: 8
	    },
	    series: [
	        {
	            name:'本年收入汇总环形图',
	            type:'pie',
	            center: ['23%', '50%'],
	            radius: ['45%', '76%'],
	            avoidLabelOverlap: false,
	            label: {
	                normal: {
	                    show: false
	                }
	            },
	            labelLine: {
	                normal: {
	                    show: false
	                }
	            },
	            data:data
	        }
	    ]
	};
	yearInPie.setOption(yearInOption);
}

//本年支出汇总环形图
function yearOutpiess(legend,data){
	var yearOutOption = {
	    tooltip: {
	        formatter: "{b}: {c} ({d}%)"
	    },
	    legend: {
	        orient: 'vertical',
	        top: '13%',
	        left: '45%',
	        data: legend,
	        itemWidth: 8,
			itemHeight: 8
	    },
	    series: [
	        {
	            name:'本年支出汇总环形图',
	            type:'pie',
	            center: ['23%', '50%'],
	            radius: ['45%', '76%'],
	            avoidLabelOverlap: false,
	            label: {
	                normal: {
	                    show: false
	                }
	            },
	            labelLine: {
	                normal: {
	                    show: false
	                }
	            },
	            data:data
	        }
	    ]
	};
	yearOutPie.setOption(yearOutOption);
}